
#include "stdafx.h"


#include "SBTESample.h"


// SBTETvFAv쐬EChEɕ`悷郂[h

#if USING_APP_WINDOW

#include "resource.h"

// --------------------------------------------------------------------------
// foCXZbgɌĂ΂
void Device_ResetCallback()
{
	OutputDebugString(_T("DEVICE RESET!\r\n"));
	return;
}

// --------------------------------------------------------------------------
// foCXXgAɌĂ΂
void Device_RestoreCallback()
{
	OutputDebugString(_T("DEVICE RESTORE!\r\n"));
	return;
}

// --------------------------------------------------------------------------
// EChETCYɌĂ΂
// screen_name : @\(\)
void Window_ResizeCallback( SBTE::SBTE_UID screen_name , UINT32 width , UINT32 height )
{
	OutputDebugString(_T("Window Resize!\r\n"));



	return;
}


// --------------------------------------------------------------------------
// bZ[WvV[W
static BOOL bRequestQuit = FALSE;
static BOOL bMoving = FALSE;
LRESULT CALLBACK WndProc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp)
{
	switch (msg)
	{
	// j[
	case WM_COMMAND:
	{
		switch ( LOWORD( wp ) )
		{
		// t@C -> 
		case IDC_CLOSE:
		{
			SendMessage( hwnd , WM_CLOSE , 0 , 0 );
		}
		break;
		}
	}
	break;
	case WM_MOVE:
	{
		bMoving = TRUE;
	}
	break;
	case WM_SIZE:
	{
		bMoving = FALSE;
	}
	break;
	// TCY
	case WM_EXITSIZEMOVE:
	{
		if ( !bMoving )
		{
			RECT c_rect;
			GetClientRect( hwnd , &c_rect );
			SBTE::RESULT res = SBTE::ResizeScreenResolution( 0 , c_rect.right , c_rect.bottom );
			if ( res != SBTE::RESULT__SUCCEEDED )
			{
				// sI
				PostQuitMessage(0);
				bRequestQuit = TRUE;
				return 0;
			}
		}
	}
	break;
	// 
	case WM_DESTROY:
	{
		PostQuitMessage(0);
		bRequestQuit = TRUE;
		return 0;
	}
	break;
	}

	return DefWindowProc(hwnd , msg , wp , lp);
}


// --------------------------------------------------------------------------
// C
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{

	// ----------------------------------------------------------------------
	// SabotenEngine

	// GW̕`惌C[̃p[^
	SBTE::SBTE_UID layer_id = 0;
	SBTE::LAYER_PARAMS layer_params;

	MakeLayerParams( layer_params );

	// NAJ[㏑w
	layer_params.ClearColor = 0xff004000;

	bRequestQuit = FALSE;
	bMoving = FALSE;

	// EChENX
	MSG msg;
	WNDCLASSEX wc = { sizeof(WNDCLASSEX)
					, CS_CLASSDC
					, WndProc
					, 0L
					, 0L
					, hInstance
					, NULL
					, NULL
					, NULL
					, MAKEINTRESOURCE(IDR_MENU1)
					, _T("SBTE_RenderToAppWindow")
					, NULL };
	RegisterClassEx( &wc );

	// EChE쐬
	HWND hWnd = CreateWindow( _T("SBTE_RenderToAppWindow")
				, _T("RenderToAppWindow")
				, WS_OVERLAPPEDWINDOW | WS_VISIBLE
				, CW_USEDEFAULT , CW_USEDEFAULT
				, WINDOW_WIDTH , WINDOW_HEIGHT
				, NULL , NULL , hInstance , NULL );

	// EChETCY
	RECT rect;
	RECT c_rect;
	GetWindowRect( hWnd , &rect );
	GetClientRect( hWnd , &c_rect);

	int wm = (rect.right - rect.left) - c_rect.right;
	int hm = (rect.bottom - rect.top) - c_rect.bottom;

	SetWindowPos( hWnd , HWND_TOP , 0 , 0 , WINDOW_WIDTH + wm , WINDOW_HEIGHT + hm , SWP_NOMOVE );

	// 
	SBTE::SBTE_INITIALIZE_PARAMS initialize_params;
	initialize_params.pD3DDevice				= NULL								;	// D3DDevice9|C^nƁAGW͎ÕfoCX쐬ɂ̃foCX𗘗pBp_d3ddevice̎QƃJE^オ܂B
	initialize_params.hWnd						= hWnd								;	// EChEAvō鎞̃EChEnhBNULLȂAGWEChE쐬B
	initialize_params.pstrWindowClassName		= NULL								;	// h_wnd = NULL̎́AEChENXl[Bh_wnd != NULL̂̎NULL
	initialize_params.pstrWindowTitleCaption	= NULL								;	// h_wnd = NULL̎́AEChE^CgLvVBh_wnd != NULL̂̎NULL
	initialize_params.bWindowed					= TRUE								;	// p_d3ddevice == NULL̎AEChE[hŋNȂ1
	initialize_params.bEnableChangeScreen		= FALSE								;	// h_wnd == NULL̎AAlt+EnterɂtXN[[hƃEChE[h̐؂ւ
	initialize_params.WindowPosX				= 0									;	// h_wnd == NULL̎̃EChEWBǂ炩̒lINT_MAXȂftHgl
	initialize_params.WindowPosY				= 0									;	
	initialize_params.AdapterIndex				= 0									;	// p_d3ddevice == NULL̎D3DDevicẽA_v^[CfbNX
	initialize_params.RefreshRate				= 0									;	// p_d3ddevice == NULL̎D3DDevice̐g
	initialize_params.pLayerParams				= &layer_params						;	// C[̃p[^ NULLȂAftHglgp
	initialize_params.pAllocatorBlockList		= NULL								;	// AP[^ubN̐ݒ
	initialize_params.LightAllocatorBlockSize	= 120								;	// CgAP[^̃ubNTCY
	initialize_params.LightAllocatorBlockCount	= 50000								;	// CgAP[^̃ubN
	initialize_params.MaxSpriteTextureSize		= 1024								;	// XvCgpeNX`[̍őTCY=XvCg̍őTCY(`XY:ꖇ̃XvCgC[W̃TCY𒴂邱Ƃ͂ł܂)0ȂAfoCX̍ől
	initialize_params.FontTemporaryTextureSize	= 1024								;	// tHgp[NeNX`̃TCYB0ȂAfoCX̍ől
	initialize_params.bYReverse					= FALSE								;	// Y+ɂ
	initialize_params.bRotReverse				= FALSE								;	// -Y]+ɂ
	initialize_params.pWinMsgProcFunc			= NULL								;	// h_wnd == NULLȂAbZ[WvV[W̊֐Ă
	initialize_params.pDeviceResetProcFunc		= Device_ResetCallback				;	// p_d3ddevice == NULLȂAfoCXZbgɂ̊֐Ă΂
	initialize_params.pDeviceRestoreProcFunc	= Device_RestoreCallback			;	// p_d3ddevice == NULLȂAfoCXXgAɂ̊֐Ă΂
	initialize_params.pWindowResizeProcFunc		= Window_ResizeCallback				;	// h_wnd == NULLp_d3ddevice == NULLȂAEChETCYύXɂ̊֐Ă΂
	initialize_params.LogMode					= SBTE::LOG_VERBOSE					;	// Oo̓[h
	initialize_params.pstrLogName				= _T("SBTE.log")					;	// Ot@CBNULLȂst@C-gq+.log
	initialize_params.MaxEffectCount			= 1000;								;	// GtFNg̓ő吔
	initialize_params.MaxEffectParticleCount	= 10000;							;	// GtFNgpXvCg̓ő吔

	if ( SBTE_FAILED( SBTE::InitializeSBTE(	layer_id				// C[IDԂ
							  , WINDOW_WIDTH						// EBhẼTCYFEBhEȂꍇAC[̃ftHglTCYƂĎQƂ
							  , WINDOW_HEIGHT
							  , initialize_params
							) ) )
	{
		// G[
		return -1;
	}
	LayerID = layer_id;

	// TEhGW̏
	if ( SBTE_FAILED( SBTE::SOUND::InitializeSoundEngine( 16 , 4 ) ) )
	{
		ErrorFinalize();
		return -1;
	}

	// ̓foCX
	if ( !InitializeInputDevices( hInstance , hWnd ) )
	{
		ErrorFinalize();
		return -1;
	}
	// ----------------------------------------------------------------------

	// Av̏
	if ( !AppSetup() )
	{
		ErrorFinalize();
		return -1;
	}

	// ^C}[쐬
	SBTE::CreateTimer();

	// XvCg쐬
	if ( !CreateSprites() )
	{
		ErrorFinalize();
		return -1;
	}


	// ^C}[쐬炱܂ł̌oߎԂZbg
	SBTE::ResetTimer();

	// -------------------------------------------------------------------------
	// [v
	while ( 1 )
	{
		// [v̌oߎԂ擾
		float elapsed_time = SBTE::UpdateTimer();
		if ( elapsed_time > 0.16f ) elapsed_time = 0.16f;

		// XvCg̍XV
		UpdateSprites( elapsed_time );

		// XvCgGW̍XVƕ`
		SBTE::RESULT res_SBTE = SBTE::UpdateSBTE( elapsed_time , FALSE , FALSE , FALSE , FALSE );
		if ( res_SBTE == SBTE::RESULT__REQUEST_CLOSE_APP )
		{
			// orُIBُȈꍇ́Aexception.logɃG[񂪏o͂܂B

			break;
		}

		// bZ[W
		while ( PeekMessage( &msg, hWnd, 0, 0 , PM_REMOVE ) )
		{
			TranslateMessage( &msg );
			DispatchMessageA( &msg );
		}

		// bZ[WŃEChEꂽI
		if ( bRequestQuit )
		{
			break;
		}

	}
	// [v
	// -------------------------------------------------------------------------
	
	// I
	Finalize( FALSE , FALSE );

	return 0;
}

#endif

