#pragma once

/*! 
	@file SBTE.h
	Saboten Engine wb_[t@C
*/ 

#include <windows.h>



namespace SBTE
{

// --------------------------------------------------------------------------
// ^
// --------------------------------------------------------------------------
typedef WCHAR	SBTE_CHAR;		//!< ^
typedef UINT32	SBTE_UID;		//!< FXȃ\[XID
typedef UINT32	SPDEF_ID;		//!< XvCg`ID
typedef UINT32	SP_ID;			//!< XvCgID
typedef UINT32	GMSP_ID;		//!< GMXvCgID
typedef UINT32	CAMERA_ID;		//!< JID
typedef UINT32	MEMORY_ID;		//!< LӂȃubNIDB֐ŃlCeBu|C^ɕϊł܂B
typedef UINT32	EFDEF_ID;		//!< GtFNg`ID

static const SBTE_UID	SBTE_UID__NULL		= 0;
static const SPDEF_ID	SPDEF_ID__NULL		= 0;
static const SP_ID		SP_ID__NULL			= 0;
static const GMSP_ID	GMSP_ID__NULL		= 0;
static const CAMERA_ID	CAMERA_ID__NULL		= 0;
static const MEMORY_ID	MEMORY_ID__NULL		= 0;
static const EFDEF_ID	EFDEF_ID__NULL		= 0;

}
// --------------------------------------------------------------------------
// bZ[WvV[WAR[obN֐^
// --------------------------------------------------------------------------

//! bZ[WvV[WR[obN
typedef LRESULT (*SBTE_WINDOW_MESSAGE_PROC_FUNC)( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam , BOOL& b_message_proced );	

//! D3DDeviceZbg̃R[obN
typedef void (*SBTE_DEVICE_RESET_PROC_FUNC)( void );

//! D3DDeviceXgÃR[obN
typedef void (*SBTE_DEVICE_RESTORE_PROC_FUNC)( void );

//! XN[TCỸR[obN
typedef void (*SBTE_WINDOW_RESIZE_PROC_FUNC)( SBTE::SBTE_UID screen_name , UINT32 width , UINT32 height );

// --------------------------------------------------------------------------
// }N
// --------------------------------------------------------------------------
//! @def }N
#define SBTE_SUCCEEDED( __RES__ )	( (__RES__) == SBTE::RESULT__SUCCEEDED )

//! @def s}N
#define SBTE_FAILED( __RES__ )		( (__RES__) == SBTE::RESULT__FAILED )


namespace SBTE
{
#pragma pack(push , 8)
#pragma pack(show)
// --------------------------------------------------------------------------
//! SBTE֐̖߂l^
enum RESULT
{
	RESULT__SUCCEEDED			= 0,	//!< 

	RESULT__INPUT_LOG_IS_EMPTY,			//!< GetNextInputDevicesLog()ɂāASẴO擾ɕԂB

	RESULT__REQUEST_CLOSE_APP,			//!< UpdateSBTE()Ivoi{^Ȃǁj
	RESULT__PENDING_AT_DEVICE_LOST,		//!< foCXXgoăXgAۗ

	RESULT__FAILED				= 0xffffffff,	//!< s
};

// --------------------------------------------------------------------------
//! O[h^
enum LOG_MODE
{
	LOG_NO_RECORD		= 0,	//!< Oo͂Ȃ
	LOG_SIMPLE			= 1,	//!< ȈՂȃOo͂
	LOG_VERBOSE			= 2,	//!< ڍׂȃOo͂

	LOG_F32				= 0xffffffff,
};

// --------------------------------------------------------------------------
//! J[uh^
/*!
	XvCg̃J[uh@w肷^łB@n
	J[uhɂ́uf[^Ŏw肵FƃvOŏ㏑^̃uhvuuh̃J[lƃXvCgeNX`̃uhv̓iK̍s܂B@n
	<table>
	<tr><td>^</td><td>J[</td><td>XvCgeNX`</td></tr>
	<tr><td>COLOR_BLEND_TYPE__COLMOD_TEXMOD</td><td>Z</td><td>Z</td></tr>
	<tr><td>COLOR_BLEND_TYPE__COLMOD_TEXADD</td><td>Z</td><td>Z</td></tr>
	<tr><td>COLOR_BLEND_TYPE__COLADD_TEXMOD</td><td>Z</td><td>Z</td></tr>
	<tr><td>COLOR_BLEND_TYPE__COLADD_TEXADD</td><td>Z</td><td>Z</td></tr>
	</table>
	L͂qfalɓKp܂Al͏ɏZƂȂ܂B@n
*/
enum COLOR_BLEND_TYPE
{
	COLOR_BLEND_TYPE__COLMOD_TEXMOD		= 0,		//!< J[ZAXvCgeNX`Z
	COLOR_BLEND_TYPE__COLMOD_TEXADD		= 2,		//!< J[ZAXvCgeNX`Z
	COLOR_BLEND_TYPE__COLADD_TEXMOD		= 3,		//!< J[ZAXvCgeNX`Z
	COLOR_BLEND_TYPE__COLADD_TEXADD		= 4,		//!< J[ZAXvCgeNX`Z

	COLOR_BLEND_TYPE__F32		= 0xffffffff,
};

// --------------------------------------------------------------------------
// C[֘A
// --------------------------------------------------------------------------
//! C[̕`p[^FɃR[obN֐ɓn
struct LAYER_PRESENT_PARAMS
{
	// ------------------------------------------------------------------
	// WindowsŗL̃p[^
	LPDIRECT3DDEVICE9*	ppD3DDevice;		//!< D3DDevice|C^
	D3DVIEWPORT9*		pViewPort;			//!< `pr[|[g
	LPDIRECT3DTEXTURE9	ppTexture;			//!< `peNX`
	// ------------------------------------------------------------------

	SBTE_UID	LayerID;					//!< C[ID

	// obNobt@֓]ۂ̂S_ւ̎Q
	float*		pvPt;						//!< obNobt@]p_Pos [4x2]
	float*		pvUV;						//!< obNobt@]p_UV [4x2]
	float*		pvColor;					//!< obNobt@]p_Color [4x4]

	// ̑p[^ւ̎Q
	UINT32*		pPriority;					//!< vCIeBlւ̎Q
	UINT32*		pClearColor;				//!< NAJ[lւ̎Q
	float*		pfClearZ;					//!< NAZlւ̎Q
	BOOL*		pbEnableRender;				//!< _OLݒlւ̎Q
	BOOL*		pbClearColor;				//!< NAJ[Lݒlւ̎Q
	BOOL*		pbClearZ;					//!< OAZLݒlւ̎Q

	// Read only params
	UINT32		LayerWidth;					//!< C[̃TCY()
	UINT32		LayerHeight;				//!< C[̃TCY()

	UINT32		ReserveWidth;				//!< C[̊mۃTCY() : DirectXȂ2^n
	UINT32		ReserveHeight;				//!< C[̊mۃTCY() : DirectXȂ2^n
};

// --------------------------------------------------------------------------
// C[̃R[obN֐^
// --------------------------------------------------------------------------
//! C[R[obN֐̌^
typedef		BOOL (*LAYER_CUSTOM_PROCESS_CALLBACK_FUNC)( LAYER_PRESENT_PARAMS* p_lpp );

//! C[̃TCYOR[obN֐̌^
typedef		BOOL (*CALLBACK_FUNC__LAYER_PRE_RESIZE_CUSTOM_PROCESS)( const SBTE::LAYER_PRESENT_PARAMS* p_lpp
								  , UINT32& ret_layer_new_width , UINT32& ret_layer_new_height
								  , UINT32& ret_layer_new_logical_width , UINT32& ret_layer_new_logical_height
								  , UINT32 screen_new_width , UINT32 screen_new_height );

//! C[̃TCY㏈R[obN֐̌^
typedef		BOOL (*CALLBACK_FUNC__LAYER_POST_RESIZE_CUSTOM_PROCESS)( const SBTE::LAYER_PRESENT_PARAMS* p_lpp
								  , UINT32& ret_layer_draw_rect_left , UINT32& ret_layer_draw_rect_top
								  , UINT32& ret_layer_draw_rect_width , UINT32& ret_layer_draw_rect_height
								  , UINT32 layer_new_width , UINT32 layer_new_height
								  , UINT32 screen_new_width , UINT32 screen_new_height );

// --------------------------------------------------------------------------
//! C[̐p[^
struct LAYER_PARAMS
{
	const SBTE_CHAR*	pName;		//!< C[

	//! C[̃GCAX
	/*! Lȕʂ̃C[̖Ow肷ƁÃC[ɍۂ鑀
		AliasɎw肵C[ɑ΂鑀ɂȂB
		`敉׃IvV̍ɉăC[̍팸ꍇȂǂɎgB
	*/
	const SBTE_CHAR*	pAliasName;

	SBTE_UID			ScreenID;	//!< (\) 0w肷

	// ------------------------------------------------------------------
	// WindowsŗL̃p[^
	D3DFORMAT	ColorFormat;		//!< _O^[Qbg̃tH[}bg

	BOOL		bEnableDepthBuffer;	//!< fvXobt@̐ݒ
	D3DFORMAT	DepthFormat;

	UINT32		LayerWidth;			//!< C[̃TCY()
	UINT32		LayerHeight;		//!< C[̃TCY()

	UINT32		ReserveWidth;		//!< C[̊mۃTCY() : DirectXȂ2^n
	UINT32		ReserveHeight;		//!< C[̊mۃTCY() : DirectXȂ2^n

	UINT32		LogicalWidth;		//!< XvCgp_TCY()
	UINT32		LogicalHeight;		//!< XvCgp_TCY()

	INT32		ScreenDrawPosX;		//!< XN[ւ̓]` X
	INT32		ScreenDrawPosY;		//!< XN[ւ̓]` Y
	UINT32		ScreenDrawWidth;	//!< XN[ւ̓]` Width
	UINT32		ScreenDrawHeight;	//!< XN[ւ̓]` Height

	// ------------------------------------------------------------------

	UINT32		Priority;			//!< C[̗DxA傫l̃C[ɕ`悳B
	UINT32		ClearColor;			//!< NAJ[
	float		fClearZ;			//!< NAZl
	BOOL		bClearColor;		//!< `JnOɎwJ[ŃNA
	BOOL		bClearZ;			//!< `JnOɎwZlŃNA

	// R[obN
	LAYER_CUSTOM_PROCESS_CALLBACK_FUNC		pfuncInitialize;			//!< C[̏ɌĂ΂R[obN֐BVF[_[̏ȂǂɁB
	LAYER_CUSTOM_PROCESS_CALLBACK_FUNC		pfuncPreRender;				//!< BeginSceneɌĂ΂R[obN֐BVF[_[̏ȂǂɁB
	LAYER_CUSTOM_PROCESS_CALLBACK_FUNC		pfuncPreEffect;				//!< PreRenderANAOɌĂ΂R[obN֐BNULLɐݒAFALSEԂƁAC[NAB
	LAYER_CUSTOM_PROCESS_CALLBACK_FUNC		pfuncActivate;				//!< `ΏۃC[ƂȂɌĂ΂R[obN֐BVF[_[̐ݒȂǂɁB
	LAYER_CUSTOM_PROCESS_CALLBACK_FUNC		pfuncPostRender;			//!< obNobt@ւ̓]ʒOɌĂ΂R[obN֐BFALSEԂƁA]ʂLZB|XgGtFNgȂǂɁB
	LAYER_CUSTOM_PROCESS_CALLBACK_FUNC		pfuncRelease;				//!< C[̍폜ɌĂ΂R[obN֐BVF[_[̊JȂǂɁB
	CALLBACK_FUNC__LAYER_PRE_RESIZE_CUSTOM_PROCESS	pfuncPreResize;		//!< XN[TCY钼OɌĂ΂R[obN֐B
	CALLBACK_FUNC__LAYER_POST_RESIZE_CUSTOM_PROCESS	pfuncPostResize;	//!< XN[TCYꂽŌĂ΂R[obN֐B
};

// --------------------------------------------------------------------------
//!	XvCg`p[^
struct SPRITE_DEFINE_PARAMS
{
	INT32			Priority;											//!< DxFl傫قǎOɕ`B20bit̂ݗL
	BOOL			bAnimation;											//!< UVAj[VLɂB
	BOOL			bStretchH;											//!< C[̘_TCYɍ킹āAC[Wgk
	BOOL			bStretchV;											//!< C[̘_TCYɍ킹āAC[Wgk
	BOOL			bCenterPoint;										//!< C[W̒\W_ɂ
	const SBTE_CHAR*	pstrImagePath;									//!< C[W̃pXFhCu^[t̐΃pX.exȇ΃pX										<< vmF
	INT32			HorizontalOrigin;									//!< XvCgX\Wn[0:[_ŉE+][1:S_ŉE+][2:E[_ō+]
	INT32			VerticalOrigin;										//!< XvCgY\Wn[0:[_ŉ+][1:S_ŏ+][2:E[_ŉ+]	<< vmF
	BOOL			bAutoAnimation;										//!< UVAj[VFoߎԂɏ]ĎŃAj[V
	BOOL			bAutoLoop;											//!< UVAj[VFŃ[v
	BOOL			bMatrixAnimation;									//!< UVAj[VFsƗ𕪗Aj[V
	float			fAutoStep;											//!< UVAj[VFAj[VsƂ́AR}̎[sec]
	INT32			AnimationCount;										//!< UVAj[VFőR}
	INT32			AnimationChipWidth;									//!< UVAj[VFR}TCY()
	INT32			AnimationChipHeight;								//!< UVAj[VFR}TCY()
	BOOL			bSaturation;										//!< Zs
	BOOL			bAntiAlias;											//!< A`GCAXs
	BOOL			bReverseH;											//!< C[W𐅕ɔ]
	BOOL			bReverseV;											//!< C[W𐂒ɔ]
	float			fDefineScale;										//!< `ŗL̃XP[lA̒`ō쐬XvCgSĂɑ΂KpXP[l
};

// --------------------------------------------------------------------------
//! v~eBuXvCg^Cv
enum TOFU_SPRITE_TYPE
{
	TOFU_SPRITE_TYPE_POINT			= 0,	//!< 1sNZ̓_XvCg
	TOFU_SPRITE_TYPE_LINE,					//!< CXvCg
	TOFU_SPRITE_TYPE_RECTANGLE,				//!< `XvCg
	TOFU_SPRITE_TYPE_RECTANGLE_LINE,		//!< Cɂ`()
	TOFU_SPRITE_TYPE_SPRITE,				//!< v~eBuXvCgȊO

	TOFU_SPRITE_TYPE_SIZE,
	TOFU_SPRITE_TYPE_F32			= 0xffffffff
};

// --------------------------------------------------------------------------
//! tHgp[^
struct FONT_PARAMS
{
	UINT32	uiHeight;					//!< SW
	UINT32	uiWeight;					//!< TCY(pt)
	BOOL	bItalic;					//!< C^bN
	BOOL	bUnderLine;					//!< 
	BOOL	bStrikeOut;					//!< ł
	UINT32	uiFixedPitch;				//!< Œ蕝ɂ
	UINT32	uiDefaultCRYStep;			//!< ftHg̉ssNZ
	BOOL	bAA;						//!< A`GCAXLɂ
	WCHAR*	pstrFontName;				//!< tHgB"lrSVbN"ȂǁB

	FONT_PARAMS(){ ZeroMemory( this , sizeof(FONT_PARAMS) ); };
};

// --------------------------------------------------------------------------
//! vZς݃RW̎擾p\
struct GMSP_CALCED_COLLISION_PARAMS
{
	static const UINT32 DATA_COUNT = 2;

	SBTE_UID	PartsName;					//!< p[c
	UINT32		Type;						//!< 0:sphere 1:capsule
	UINT32		Index;						//!< ޕʃCfbNXł͂ȂAʂԍ(Sph2ACap4Index=3ȂACap2)

	float		v2Collision_CenterBegin[2];	//!< Sph̒SCap̎n_
	float		v2Collision_End[2];			//!< Cap̏I_F͖̎
	float		fRadius;					//!< a

	/*! LtOB̒lFALSEŃRW擾ꂽꍇ́A
	{̃RWGMSP_SetCollisionSetting()֐b_force_calcp[^ŗLꂽƂ\܂B
	*/
	BOOL		bEnable;

	INT32		aIntParams[DATA_COUNT];		//!< ^f[^
	float		aFloatParams[DATA_COUNT];	//!< _^f[^
};

// --------------------------------------------------------------------------
//! C[Wp[^擾p^
struct GMSP_PARTS_IMAGE_PARAMS
{
	UINT32		ImageColor;					//!< F
	UINT32		IPAnimatedFrame;			//!< Aj[Vt[
	UINT32		IPAnimatedRow;				//!< sAj[V̍s

	UINT32		Priority;					//!< Dx
	BOOL		bVisible;					//!< \
	BOOL		bReverseH;					//!< ]
	BOOL		bReverseV;					//!< c]

	GMSP_PARTS_IMAGE_PARAMS()
		: ImageColor( 0 )
		, IPAnimatedFrame( 0 )
		, IPAnimatedRow( 0 )
		, Priority( 0 )
		, bVisible( FALSE )
		, bReverseH( FALSE )
		, bReverseV( FALSE )
	{};
};

// --------------------------------------------------------------------------
//! Cxgp[^擾p^
struct GMSP_EVENT_PARAMS
{
	static const UINT32 EVENT_STRING_LENGTH = 128;

	SBTE_CHAR	strEvent[ EVENT_STRING_LENGTH ];
	SBTE_UID	PartsName;						//!< Cxgp[cID
	float		matPartsWorld[16];				//!< Cxgp[c̃[hs

	GMSP_EVENT_PARAMS()
		: PartsName( 0 )
	{
		strEvent[0] = 0;
	};
};


// --------------------------------------------------------------------------
//! ̓foCX񋓂Œ\̓p[^
struct INPUT_DEVICE_ENUM_MINIMUM_CAPS
{
	BOOL	bEnableKeyboard;						//!< L[{[hgp
	BOOL	bEnableMouse;							//!< }EXgp
	BOOL	bEnableGameController;					//!< Q[Rg[[gp

	UINT32	dwMinimumKeyboardButtonNumber;			//!< gpL[{[h̍Œ{^

	UINT32	dwMinimumMouseAxisNumber;				//!< gp}EX̍ŒᎲ
	UINT32	dwMinimumMouseButtonNumber;				//!< gp}EX̍Œ{^

	UINT32	dwMinimumGameControllerAxisNumber;		//!< gpQ[Rg[[̍Œgp
	UINT32	dwMinimumGameControllerButtonNumber;	//!< gpQ[Rg[[̍Œgp{^
	UINT32	dwMinimumGameControllerPovNumber;		//!< gpQ[Rg[[̍ŒgpPov

	INPUT_DEVICE_ENUM_MINIMUM_CAPS()
		: bEnableKeyboard( FALSE )
		, bEnableMouse( FALSE )
		, bEnableGameController( FALSE )
		, dwMinimumKeyboardButtonNumber( 0 )
		, dwMinimumMouseAxisNumber( 0 )
		, dwMinimumMouseButtonNumber( 0 )
		, dwMinimumGameControllerAxisNumber( 0 )
		, dwMinimumGameControllerButtonNumber( 0 )
		, dwMinimumGameControllerPovNumber( 0 )
	{};

};

// --------------------------------------------------------------------------
//! ̓foCX̓̓O
/*!
	Cxg̓Z̏ԂωƂɂ̂ݔBJnƉs̓AvŔ肷KvB
*/
struct INPUT_DEVICE_LOG
{
	UINT32	dwDeviceID;			//!< ̓foCXIDBL[{[h̏ꍇ0
	UINT32	dwCellID;			//!< ̓ZIDBL[{[h̏ꍇ"DIK_*"̒l
	float	fAnalogValue;		//!< K͒l( -1`1 )A( ȊO0`1 )
	UINT32	dwDigitalValue;		//!< OFF:0 ON:1

	INPUT_DEVICE_LOG()
		: dwDeviceID( 0 )
		, dwCellID( 0 )
		, fAnalogValue( 0.0f )
		, dwDigitalValue( 0 )
	{};
};

#pragma pack( pop )
#pragma pack(show)

// --------------------------------------------------------------------------
// ֐
// --------------------------------------------------------------------------
// VXen
// --------------------------------------------------------------------------
// 

//! GWݒ̒ǉp[^\
/*!
	@par EChEƃfoCX̃[h
		(p_d3ddevice == NULL) && (h_wnd == NULL) : foCXƃEChEGW쐬BP̃EChÊ݁BtXN[\B@n
		(p_d3ddevice == NULL) && (h_wnd != NULL) : Avō쐬EChEɑ΂āAGW쐬foCXŕ`BWPFȂǁB̃EChE\AtXN[͂łȂB@n
		(p_d3ddevice != NULL) && (h_wnd == NULL) : ̑gݍ킹͎włȂB@n
		(p_d3ddevice != NULL) && (h_wnd != NULL) : Avō쐬foCX𗘗pāAAv쐬EChEɕ`BDXCuȂǁB@n
	      
	@par TCYR[obNɂ
		  (p_d3ddevice != NULL) && (h_wnd != NULL) : TCYsB@n
	      (p_d3ddevice == NULL) && (h_wnd != NULL) : TCY\AAvŃbZ[WsAGW̃TCY֐ĂяoƁAR[obNԂB@n
	      (p_d3ddevice != NULL) && (h_wnd != NULL) : TCY\AB@n
	
	@par AP[^ubNɂ
	GWgq[vAP[^̃TCYݒ肷B@n
	GW̓q[vŒ蒷xŒ萔̃mۂāA󂫂ꍇ::new()̑ɂ烁mۂėpB@n
	@code
		UINT32 allocs[7];
		allocs[0] = 500;  allocs[1] = 20000;
		allocs[2] = 1000; allocs[3] = 2000;
		allocs[4] = 2000; allocs[5] = 1000;
		allocs[6] = 0;
	@endcode
	Ⴆ΁AL̂悤ɐݒ肵allocsnƁA500oCg x 20000ubNA1000oCg x 2000ubNA2000oCg x 1000ubNmۂB@n
	f[^̖0ݒ肵ďI[𖾎KvB@n
	::new()ɏꂽǂ́AGW̃Oɕ\B@n

	@par CgAP[^ɂ
	CgAP[^̓TCYPނ݂̂̃q[vAP[^ŁAGWœɕpɂalloc/freef[^ɎgpB@n
*/
struct SBTE_INITIALIZE_PARAMS
{
	LPDIRECT3DDEVICE9 pD3DDevice;									//<! D3DDevice9|C^nƁAGW͎ÕfoCX쐬ɂ̃foCX𗘗pBp_d3ddevice̎QƃJE^オ܂B
	HWND hWnd;														//<! EChEAvō鎞̃EChEnhBNULLȂAGWEChE쐬B
	const SBTE_CHAR* pstrWindowClassName;							//<! h_wnd == NULL̎́AEChENXl[Bh_wnd != NULL̂̎NULL
	const SBTE_CHAR* pstrWindowTitleCaption;						//<! h_wnd == NULL̎́AEChE^CgLvVBh_wnd != NULL̂̎NULL
	BOOL bWindowed;													//<! p_d3ddevice == NULL̎AEChE[hŋNȂ1
	BOOL bEnableChangeScreen;										//<! h_wnd == NULL̎AAlt+EnterɂtXN[[hƃEChE[h̐؂ւ
	INT32 WindowPosX;												//<! h_wnd == NULL̎̃EChEW(X)Bpos_x/ŷǂ炩̒lINT_MAXȂftHgl
	INT32 WindowPosY;												//<! h_wnd == NULL̎̃EChEW(Y)B
	UINT32 AdapterIndex;											//<! p_d3ddevice == NULL̎D3DDevicẽA_v^[CfbNX
	UINT32 RefreshRate;												//<! p_d3ddevice == NULL̎D3DDevice̐g
	const LAYER_PARAMS* pLayerParams;								//<! C[̃p[^ NULLȂAftHglgp
	const UINT32* pAllocatorBlockList;								//<! AP[^ubN̐ݒBNULLȂftHgTCYŊmۂ
	UINT32 LightAllocatorBlockSize;									//<! CgAP[^̃ubNTCY
	UINT32 LightAllocatorBlockCount;								//<! CgAP[^̃ubN
	UINT32 MaxSpriteTextureSize;									//<! XvCgobt@eNX`̍őTCY=XvCg̍őTCY(`XY:ꖇ̃XvCgC[W̃TCY𒴂邱Ƃ͂ł܂)0ȂAfoCX̍ől
	UINT32 FontTemporaryTextureSize;								//<! tHgp[NeNX`̃TCYB0ȂAfoCX̍ől
	BOOL bYReverse;													//<! Y+ɂ
	BOOL bRotReverse;												//<! -Y]+ɂ
	SBTE_WINDOW_MESSAGE_PROC_FUNC pWinMsgProcFunc;					//<! h_wnd == NULLȂAbZ[WvV[W̊֐Ă
	SBTE_DEVICE_RESET_PROC_FUNC pDeviceResetProcFunc;				//<! p_d3ddevice == NULLȂAfoCXZbgɂ̊֐Ă΂
	SBTE_DEVICE_RESTORE_PROC_FUNC pDeviceRestoreProcFunc;			//<! p_d3ddevice == NULLȂAfoCXXgAɂ̊֐Ă΂
	SBTE_WINDOW_RESIZE_PROC_FUNC pWindowResizeProcFunc;				//<! h_wnd == NULLp_d3ddevice == NULLȂAEChETCYύXɂ̊֐Ă΂
	LOG_MODE LogMode;												//<! Oo̓[h
	const TCHAR* pstrLogName;										//<! Ot@CBNULLȂst@C-gq+.log
	UINT32 MaxEffectCount;											//<! GtFNg̓ő吔
	UINT32 MaxEffectParticleCount;									//<! GtFNgpXvCg̓ő吔

	SBTE_INITIALIZE_PARAMS()
		: pD3DDevice				( NULL )
		, hWnd						( NULL )
		, pstrWindowClassName		( NULL )
		, pstrWindowTitleCaption	( NULL )
		, bWindowed					( TRUE )
		, bEnableChangeScreen		( TRUE )
		, WindowPosX				( INT_MAX )
		, WindowPosY				( INT_MAX )
		, AdapterIndex				( 0 )
		, RefreshRate				( 60 )
		, pLayerParams				( NULL )
		, pAllocatorBlockList		( NULL )
		, LightAllocatorBlockSize	( 120 )
		, LightAllocatorBlockCount	( 5000 )
		, MaxSpriteTextureSize		( 0 )
		, FontTemporaryTextureSize	( 0 )
		, bYReverse					( FALSE )
		, bRotReverse				( FALSE )
		, pWinMsgProcFunc			( NULL )
		, pDeviceResetProcFunc		( NULL )
		, pDeviceRestoreProcFunc	( NULL )
		, pWindowResizeProcFunc		( NULL )
		, LogMode					( LOG_NO_RECORD )
		, pstrLogName				( NULL )
		, MaxEffectCount			( 1000 )
		, MaxEffectParticleCount	( 10000 )
	{
	};
};

//! GW̏
/*!
	@param[out] ret_layer_id C[IDԂ
	@param[in] screen_width EBhẼTCY()AEBhEȂꍇAC[̃ftHglTCYƂĎQƂ
	@param[in] screen_height EBhẼTCY()AEBhEȂꍇAC[̃ftHglTCYƂĎQƂ
	@param[in] params ǉp[^ݒ肵\
*/
__declspec(dllexport) RESULT InitializeSBTE(
	  SBTE_UID& ret_layer_id
	, UINT32 screen_width
	, UINT32 screen_height
	, const SBTE_INITIALIZE_PARAMS& params
);

//! GW̃t[XV
/*! 
	@param[in] f_elapsed_time oߎ[sec]
	@param[in] b_restore_render_target TRUEȂAĂяoɐݒ肳Ă_O^[Qbg𕜋AďIB
	@param[in] b_restore_set_textures TRUEȂAĂяoɕ`pɐݒ肳ĂeNX`𕜋AďIB
	@param[in] b_restore_depth_buffer TRUEȂAĂяoɕ`pɐݒ肳ĂfvXobt@𕜋AďIB
	@param[in] b_skip_rendering TRUEȂAXvCg̍XVĕ`ȂB

	@retval RESULT__REQUEST_CLOSE_APP GWIvo({^Ȃ)
	@retval RESULT__PENDING_AT_DEVICE_LOST foCXXgoăXgAۗ
*/ 
__declspec(dllexport) RESULT UpdateSBTE( float f_elapsed_time , BOOL b_restore_render_target = FALSE , BOOL b_restore_set_textures = FALSE , BOOL b_restore_depth_buffer = TRUE , BOOL b_skip_rendering = FALSE );

//! GW̉
__declspec(dllexport) RESULT ReleaseSBTE( void );

// --------------------------------------------------------------------------
//! ̓foCX̏
/*!
	VXeɐڑĂ̓foCXQAvP[VŎgp\ɂB

	@param[in] min_caps dl\ɂfoCX̍Œ\͂LqB
	@param[in] h_instance foCXgpEBhELAvP[ṼnhBNULLnꍇSBTEǗnhgBGetInstanceHandle֐NULLԂꍇ́A[U[ǗnhnKvB
	@param[in] h_wnd foCXgpEBhẼnhBNULLnꍇSBTEǗnhgBGetWindowHandle֐NULLԂꍇ́A[U[ǗnhnKvB
*/
__declspec(dllexport) RESULT InitializeInputDevices( INPUT_DEVICE_ENUM_MINIMUM_CAPS min_caps , HINSTANCE h_instance , HWND h_wnd );

//! ̓foCX̉
/*!
	VXeɐڑĂ̓foCXQB
*/
__declspec(dllexport) RESULT ReleaseInputDevices( void );

//! Lȓ̓foCX擾
/*!
	@param[out] ret_keyboard_count L[{[h̐
	@param[out] ret_controller_count Q[Rg[[̐
	@param[out] pa_ret_controller_ids Q[Rg[[ID\Amax_controller_count̒UINT32^z
	@param[in] max_controller_count 擾őQ[Rg[[
*/
__declspec(dllexport) RESULT GetControllers( UINT32& ret_keyboard_count , UINT32& ret_controller_count , UINT32* pa_ret_controller_ids , UINT32 max_controller_count );

//! ̓foCXXV
/*!
	VXeɐڑĂ̓foCXQB

	@param[in] elapsed oߎ
*/
__declspec(dllexport) RESULT UpdateInputDevices( float elapsed );

//! ̓foCX̓͗𓾂
/*!
	UpdateInputDevice()s܂łɓ͂ꂽ͒l̃O擾܂B@n
	RESULT__INPUT_LOG_IS_EMPTYԂ܂ŌJԂs邱ƂŁASĂ̓͂擾ł܂B
	RESULT__INPUT_LOG_IS_EMPTYԂ́Aret_input_device_logɓ͒l͕Ԃ܂B@n
	擾O̓VXeォ폜܂B

	@param[out] ret_input_device_log 擾郍Of[^̊i[B
*/
__declspec(dllexport) RESULT GetNextInputDevicesLog( INPUT_DEVICE_LOG& ret_input_device_log );

//! ̓foCX̖O𓾂
/*!
	@param[out] ret_str_name 擾Oi[obt@
	@param[in] max_name_size ret_str_namẽobt@
	@param[in] device_id 擾ΏۃfoCXID
*/
__declspec(dllexport) RESULT GetDeviceName( SBTE_CHAR* ret_str_name , UINT32 max_name_size , UINT32 device_id );

//! ̓foCX̃Z̐𓾂
/*!
	@param[out] ret_axes_x X̃Z
	@param[out] ret_axes_y ỸZ
	@param[out] ret_axes_z Z̃Z
	@param[out] ret_axes_rx X̃Z
	@param[out] ret_axes_ry ỸZ
	@param[out] ret_axes_rz Z̃Z
	@param[out] ret_axes_other XYZȊO̎̃Z
	@param[out] ret_buttons {^̃Z
	@param[out] ret_povs POṼZ
	@param[in] device_id 擾ΏۃfoCXID
*/
__declspec(dllexport) RESULT GetControllerCellCount(
	  UINT32& ret_axes_x
	, UINT32& ret_axes_y
	, UINT32& ret_axes_z
	, UINT32& ret_axes_rx
	, UINT32& ret_axes_ry
	, UINT32& ret_axes_rz
	, UINT32& ret_axes_other
	, UINT32& ret_buttons
	, UINT32& ret_povs
	, UINT32 device_id );

//! ̓foCX̃Z𓾂
/*!
	ez̃TCÝAOGetControllerCellCount()擾܂B
	NULLnzɂĂ͎擾΂܂B

	@param[out] pa_ret_axes_x 擾X̃ZID̈ꗗi[z
	@param[out] pa_ret_axes_y 擾ỸZID̈ꗗi[z
	@param[out] pa_ret_axes_z 擾Z̃ZID̈ꗗi[z
	@param[out] pa_ret_axes_rx 擾X]̃ZID̈ꗗi[z
	@param[out] pa_ret_axes_ry 擾Y]̃ZID̈ꗗi[z
	@param[out] pa_ret_axes_rz 擾Z]̃ZID̈ꗗi[z
	@param[out] pa_ret_axes_other 擾XYZȊO̎̃ZID̈ꗗi[z
	@param[out] pa_ret_buttons 擾{^̃ZID̈ꗗi[z
	@param[out] pa_ret_povs 擾PoṽZID̈ꗗi[z
	@param[in] device_id 擾ΏۃfoCXID
*/
__declspec(dllexport) RESULT GetControllerCells(
	  UINT32* pa_ret_axes_x
	, UINT32* pa_ret_axes_y
	, UINT32* pa_ret_axes_z
	, UINT32* pa_ret_axes_rx
	, UINT32* pa_ret_axes_ry
	, UINT32* pa_ret_axes_rz
	, UINT32* pa_ret_axes_other
	, UINT32* pa_ret_buttons
	, UINT32* pa_ret_povs
	, UINT32 device_id );

// --------------------------------------------------------------------------
//! TEhGW
namespace SOUND
{

// --------------------------------------------------------------------------
// ^
typedef UINT32	SOUND_ID;		//!< ʂ̃TEhID

enum CREATE_FLAG
{
	AUTO_RELEASE	= 0x01,
	AUTO_PLAY		= 0x02,
	LOOP			= 0x04,
};

//! TEh̎ގʎq
enum SOUND_SUB_CATEGORY_TYPE
{
	SSC_PCM = 0,
	SSC_OGG_VORBIS_16BIT,
	SSC_OGG_VORBIS_16BIT_STREAM,
	SSC_MP3_ACM,

	SSC_ERROR,
	SSC_FORCE_32BIT = 0xffffffff
};


// --------------------------------------------------------------------------
// GWn

//! TEhGW
/*!
	TEhGWWaveAOggVorbisTEh̍Đ\ɂ܂B@n
	OggVorbisTEhĐꍇ́AOggVorbisDLLgpĉB܂A̍ۃ\tgEFAɂOggVorbis̃CZX\LfĉB

	@param[in] max_sounds ő哯Đ
	@param[in] cannel_num ő`l
	@param[in] p_allocator_block_list TEhGWgpAP[^ubN̐ݒBNULLȂftHgTCYŊmۂBAP[^ubN̏ڍׂɂĂInitializeSBTE()֐̍ڂQƂĉB
	@param[in] stream_buffer_size Xg[Đobt@̃TCYFVXeœK؂ȒlɕύX\
	@param[in] f_update_interval TEhXVԊu[sec]
	@param[in] f_release_fadeout_time TEh̃tF[hAEg[sec]
	@param[in] f_master_volume S̃{[B0`1
	@param[in] master_frequency Đg[Hz]
	@param[in] ogg_vorbis_stream_buffering_time OggVorbisXg[Đ̃Xg[obt@TCY[sec]
*/
__declspec(dllexport) RESULT InitializeSoundEngine(	  UINT32		max_sounds = 16
													, UINT32		cannel_num = 1
													, const UINT32*	p_allocator_block_list = NULL
													, UINT32		stream_buffer_size = 256 * 1024
													, float			f_update_interval = 0.05f
													, float			f_release_fadeout_time = 0.25f
													, float			f_master_volume = 1.0f
													, UINT32		master_frequency = 44100
													, UINT32		ogg_vorbis_stream_buffering_time = 1
												);

//! TEhGW
/*!
	TEhGW܂B
*/
__declspec(dllexport) RESULT ReleaseSoundEngine( void );

//! libogg̃CZX\L擾
/*!
	@param[out] ret_text_buf 擾CZX\L̊i[obt@B8KBx̃TCYKvłB
	@param[in] text_buf_size ret_text_buf̃TCYBTCYsꍇ̓CZX\Lrőł؂܂B
*/
__declspec(dllexport) RESULT GetLibOggLicense( SBTE_CHAR* ret_text_buf , UINT32 text_buf_size );

//! libvorbis̃CZX\L擾
/*!
	@param[out] ret_text_buf 擾CZX\L̊i[obt@B8KBx̃TCYKvłB
	@param[in] text_buf_size ret_text_buf̃TCYBTCYsꍇ̓CZX\Lrőł؂܂B
*/
__declspec(dllexport) RESULT GetLibVorbisLicense( SBTE_CHAR* ret_text_buf , UINT32 text_buf_size );

//! libogg̃o[W\L擾
/*!
	@param[out] ret_text_buf 擾o[W\L̊i[obt@B256Bytex̃TCYKvłB
	@param[in] text_buf_size ret_text_buf̃TCYBTCYsꍇ̓o[W\Lrőł؂܂B
*/
__declspec(dllexport) RESULT GetLibOggVersion( SBTE_CHAR* ret_text_buf , UINT32 text_buf_size );

//! libvorbis̃o[W\L擾
/*!
	@param[out] ret_text_buf 擾o[W\L̊i[obt@B256Bytex̃TCYKvłB
	@param[in] text_buf_size ret_text_buf̃TCYBTCYsꍇ̓o[W\Lrőł؂܂B
*/
__declspec(dllexport) RESULT GetLibVorbisVersion( SBTE_CHAR* ret_text_buf , UINT32 text_buf_size );

//! TEh̃`lʏ󋵂擾
/*!
	@param[out] pa_channel_sound_count `lɃ[hĂTEh̐i[obt@BInitializeSoundEngine() ɓn cannel_num * sizeof(UINT32) ̃TCYKvłB
	@param[out] pa_channel_playing_sound_count `lɃ[hĂĐTEh̐i[obt@BInitializeSoundEngine() ɓn cannel_num * sizeof(UINT32) ̃TCYKvłB
	@param[out] p_stream_count [hĂXg[TEh̐i[
	@param[out] p_stream_size [hĂXg[TEh̑TCYi[
*/
__declspec(dllexport) RESULT GetSoundCounts( UINT32* pa_channel_sound_count , UINT32* pa_channel_playing_sound_count , UINT32* p_stream_count , UINT32* p_stream_size );

//! [hĂTEh̏󋵂擾
/*!
	@param[out] ret_image_count [hĂTEh̑
	@param[out] ret_image_size [hĂTEh̑TCY
*/
__declspec(dllexport) RESULT GetImageStatus( UINT32& ret_image_count , UINT32& ret_image_size );

//! ݂̑̂̏Ԃ擾
/*!
	TEhGW InitializeSoundEngine() ɓn f_update_interva [b]Ԋu
	s܂ÂۂɏɗvԂ擾܂B
*/
__declspec(dllexport) float GetAvarageLoad( void );

//! }X^[{[̐ݒ
/*!
	@param[in] f_volume {[A0`1Ŏw肷B
*/
__declspec(dllexport) RESULT SetMasterVolume( float f_volume );

//! GW̍ĐgύX
/*!
	@param[in] frequency ݒ肷g[Hz]
*/
__declspec(dllexport) RESULT SetMasterFrequency( UINT32 frequency );


//! SẴTEhꎞ~
__declspec(dllexport) RESULT AllPause( void );

//! SẴTEhĊJ
__declspec(dllexport) RESULT AllResume( void );

//! SẴTEh~
__declspec(dllexport) RESULT AllStop( void );

//! `l̓Đݒ
/*!
	@param[in] channel_id `lԍ
	@param[in] simultaneous_count Đ
*/
__declspec(dllexport) RESULT SetChannelSimultaneousCount( UINT32 channel_id , UINT32 simultaneous_count );

//! `l̃{[ݒ
/*!
	@param[in] channel_id `lԍ
	@param[in] f_volume {[A0`1Ŏw肷
*/
__declspec(dllexport) RESULT SetChannelVolume( UINT32 channel_id , float f_volume );


// --------------------------------------------------------------------------
// TEh֘A

//! WAVEC[WTEhC[W쐬
/*!
	WAVEt@C̃C[ŴݑΉĂ܂B

	@param[in] pstr_name TEhC[W̖O
	@param[in] p_image C[W̃\[X
	@param[in] image_size \[XTCY
	@param[in] b_auto_free ̃C[WgTEhȂC[WŔj( TEhGW̃C[WIuWFNgj܂Bp_imagefree()킯ł͂܂)B̃tOw肷ꍇÃR[hŃTEh쐬ĉB
	@param[out] p_ret_image_id 쐬TEhC[WID̊i[BNULLȂC[WIDԂȂȀꍇGetResUID( pstr_name )ƂID𓾂邱Ƃł܂B
*/
__declspec(dllexport) RESULT LoadPCMImageFormMemory( SBTE_CHAR* pstr_name , BYTE* p_image , UINT32 image_size , BOOL b_auto_free , SBTE_UID* p_ret_image_id = NULL );

//! t@CTEhC[W쐬
/*!
	@param[in] pstr_name TEhC[W̖O
	@param[in] str_file_name t@CpX
	@param[in] b_auto_free ̃C[WgTEhȂC[WŔjB̃tOw肷ꍇÃR[hŃTEh쐬ĉB
	@param[in] type TEh̎
	@param[out] p_ret_image_id 쐬TEhC[WID̊i[BNULLȂC[WIDԂȂȀꍇGetResUID( pstr_name )ƂID𓾂邱Ƃł܂B
*/
__declspec(dllexport) RESULT LoadSoundImage( SBTE_CHAR* pstr_name , SBTE_CHAR* str_file_name , BOOL b_auto_free , SOUND_SUB_CATEGORY_TYPE type , SBTE_UID* p_ret_image_id = NULL );

//! TEhC[WjB
/*!
	@param[in] sound_image_uid TEhC[WID
*/
__declspec(dllexport) void FreeSoundImage( SBTE_UID sound_image_uid );

//! WAVEC[WTEhƂčĐ
/*!
	WAVEt@C̃C[ŴݑΉĂ܂B

	@param[in] channel Đ`lio[
	@param[in] priority DxB`lŜ̓Đ𒴂ꍇAl傫TEhDIɍĐB
	@param[in] p_image C[W̃AhX
	@param[in] image_size C[WTCY
*/
__declspec(dllexport) SOUND_ID PlayOncePCMFormMemory( UINT32 channel , UINT32 priority , BYTE* p_image , UINT32 image_size );

//! t@CTEhƂčĐ
/*!
	@param[in] channel Đ`lio[
	@param[in] priority DxB`lŜ̓Đ𒴂ꍇAl傫TEhDIɍĐB
	@param[in] str_file_name t@CpX
	@param[in] type TEh̎
*/
__declspec(dllexport) SOUND_ID PlayOnce( UINT32 channel , UINT32 priority , const SBTE_CHAR* str_file_name , SOUND_SUB_CATEGORY_TYPE type );


//! Xg[TEh쐬
/*!
	Xg[TEh́AOggVorbiŝݑΉĂ܂B

	@param[in] channel Đ`lio[
	@param[in] priority DxB`lŜ̓Đ𒴂ꍇAl傫TEhDIɍĐB
	@param[in] str_file_name t@CpX
	@param[in] type TEh̎
	@param[in] b_auto_play ɍĐJn
	@param[in] b_loop Ń[vĐ 
	@param[in] b_auto_delete ĐIATEhŔjB
*/
__declspec(dllexport) SOUND_ID CreateStreamSound( UINT32 channel , UINT32 priority , const SBTE_CHAR* str_file_name , SOUND_SUB_CATEGORY_TYPE type , BOOL b_auto_play , BOOL b_loop , BOOL b_auto_delete );

//! Xg[TEhj
/*!
	@param[in] sound_id jXg[TEhID
*/
__declspec(dllexport) void DeleteStreamSound( SOUND_ID sound_id );


//! TEhZbgt@C[hB
/*!
	TEhZbgt@CSoundED.exeō쐬܂B[hꂽX̃TEh́ACreateSound()ōĐĉB

	@param[in] str_file_path TEhZbgt@CpX
	@param[in] str_set_name TEhZbg
*/
__declspec(dllexport) RESULT LoadSoundSet( const SBTE_CHAR* str_file_path , const SBTE_CHAR* str_set_name );


//! TEhZbgj
/*!
	@param[in] str_set_name TEhZbg
*/
__declspec(dllexport) void FreeSoundSet( const SBTE_CHAR* str_set_name );



// --------------------------------------------------------------------------
// TEhɑ΂鑀

//! TEh쐬
/*!
	LoadSoundImage֐ŌĂ񂾃TEhĐ܂B

	@param[in] sound_name TEhC[W̖O
	@param[in] channel dl`lio[
	@param[in] priority Dx
	@param[in] create_flags ĐtOBb0:AutoDel b1:AutoPlay b2:Loop
*/
__declspec(dllexport) SOUND_ID	CreateSound( SBTE_UID sound_name , UINT32 channel , UINT32 priority , UINT32 create_flags );

//! TEhZbg̃TEh쐬
/*!
	TEhZbgt@C烍[hTEht@C쐬܂B@n
	`lADxAĐtOɂĂSoundEDł̐ݒlKp܂B̒lʓrݒ肵ꍇ́A
	sound_name = set_name:define_nameƂāACreateSound( GetResUID(sound_name) , channel , priority , create_flags )ĂŉB

	@param[in] sound_name `
*/
__declspec(dllexport) SOUND_ID	CreateSound( SBTE_UID sound_name );

//! TEhj
/*!
	@param[in] sound_id ΏۃTEhID
*/
__declspec(dllexport) void 	FreeSound( SOUND_ID sound_id );

//! TEhĐJn/ĊJ
/*!
	@param[in] sound_id ΏۃTEhID
*/
__declspec(dllexport) RESULT Play( SOUND_ID sound_id );

//! TEh~
/*!
	@param[in] sound_id ΏۃTEhID
*/
__declspec(dllexport) RESULT Stop( SOUND_ID sound_id );

//! TEhꎞ~
/*!
	@param[in] sound_id ΏۃTEhID
*/
__declspec(dllexport) RESULT Pause( SOUND_ID sound_id );

//! TEh̃{[ύX
/*!
	@param[in] sound_id ΏۃTEhID
	@param[in] f_volume {[l 0`1
*/
__declspec(dllexport) RESULT SetVolume( SOUND_ID sound_id , float f_volume );

//! TEh̃pύX
/*!
	@param[in] sound_id ΏۃTEhID
	@param[in] f_pan pl -1`0`+1
*/
__declspec(dllexport) RESULT SetPan( SOUND_ID sound_id , float f_pan );

//! TEh̍ĐgύX
/*!
	@param[in] sound_id ΏۃTEhID
	@param[in] frequency g[Hz]
*/
__declspec(dllexport) RESULT SetFrequency( SOUND_ID sound_id , UINT32 frequency );

//! TEh̃[vݒύX
/*!
	@param[in] sound_id ΏۃTEhID
	@param[in] b_loop [vȂTRUE
*/
__declspec(dllexport) RESULT SetLoop( SOUND_ID sound_id , BOOL b_loop );

//! TEh̗DxύX
/*!
	@param[in] sound_id ΏۃTEhID
	@param[in] priority Dxl
*/
__declspec(dllexport) RESULT SetPriority( SOUND_ID sound_id , UINT32 priority );

//! TEh̎폜ݒ
/*!
	@param[in] sound_id ΏۃTEhID
	@param[in] b_auto_release TRUEȂ玩폜
*/
__declspec(dllexport) RESULT SetAutoRelease( SOUND_ID sound_id , BOOL b_auto_release );

//! TEh̃tF[hݒ
/*!
	@param[in] sound_id ΏۃTEhID
	@param[in] b_fade_in tF[hCȂTRUEAtF[hAEgȂFALSE
	@param[in] f_fade_time tF[h[sec]
	@param[in] b_auto_stop StF[hAEgɍĐ~ȂTRUE
*/
__declspec(dllexport) RESULT SetFade( SOUND_ID sound_id , BOOL b_fade_in , float f_fade_time , BOOL b_auto_stop );


};	//namespace SOUND
// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
//! ^C}[쐬
__declspec(dllexport) RESULT CreateTimer( void );

//! ^C}[폜
__declspec(dllexport) RESULT DeleteTimer( void );

//! OUpdateTimer(),ResetTimer()̌oߎԂ𓾂
__declspec(dllexport) float UpdateTimer( void );

//! ^C}[Zbg
__declspec(dllexport) void ResetTimer( void );

// --------------------------------------------------------------------------
//! C[ǉ
/*! 
	@param[out] ret_layer_id ǉC[IDԂB
	@param[in] params 쐬郌C[̃p[^B
*/
__declspec(dllexport) RESULT AddLayer( SBTE_UID& ret_layer_id , const LAYER_PARAMS& params );

//! C[폜
/*! 
	@param[in] layer_id 폜郌C[IDB
*/
__declspec(dllexport) RESULT RemoveLayer( SBTE_UID layer_id );

//! C[̃eNX`𓾂
/*!
	@param[out] p_ret_tex C[eNX`̃|C^
	@param[out] ret_layer_width C[̕
	@param[out] ret_layer_height C[̍
	@param[out] ret_reserved_width C[eNX`̕
	@param[out] ret_reserved_height C[eNX`̍
	@param[in] layer_id 擾郌C[ID
*/
__declspec(dllexport) RESULT GetLayerTexture( LPDIRECT3DTEXTURE9& p_ret_tex , UINT32& ret_layer_width , UINT32& ret_layer_height , UINT32& ret_reserved_width , UINT32& ret_reserved_height , SBTE_UID layer_id );

//! C[RenderTargeteNX`֕`悷邱Ƃ\񂷂BUpdateSBTE()sɕ`挋ʂB
/*!
	UpdateSBTE()sxɗ\͉B
	@param[in] p_dest_RT_texture
	@param[in] left
	@param[in] top
	@param[in] width
	@param[in] height
	@param[in] layer_id
*/
__declspec(dllexport) RESULT RegistTextureToRenderingLayer( LPDIRECT3DTEXTURE9 p_dest_RT_texture , UINT32 left , UINT32 top , UINT32 width , UINT32 height , SBTE_UID layer_id );


// --------------------------------------------------------------------------
//! \[XUID𓾂
/*!
	@param[in] resources_name Ώۃ\[X
*/
__declspec(dllexport) SBTE_UID GetResUID( const SBTE_CHAR* resources_name );

//!	foCX\[X\߃Zbg
__declspec(dllexport) RESULT DeviceResourceManualReset( void );

//!	\߃ZbgfoCX\[X𕜌
/*!
	@param[in] b_do_not_callback_device_lost_funcs XgAR[obNĂ΂Ȃ
	@param[in] b_do_device_reset foCXZbgs
	@param[in] p_new_device foCX蒼ꍇ́ÄɐVfoCX|C^w肷B
			   foCXύXȂꍇ́ANULLw肷B
			   ÂfoCX́ASBTEǗ郊\[X̔jƂɎgp邽߁Å֐I܂ŔjȂŉB
	@param[in] b_req_old_device_release p_new_device != NULL̎AÂfoCXɑ΂ĂPRelease()s邩ǂw肵܂B
*/
__declspec(dllexport) RESULT DeviceResourceManualRestore( BOOL b_do_not_callback_device_lost_funcs = false , BOOL b_do_device_reset = true , LPDIRECT3DDEVICE9 p_new_device = NULL , BOOL b_req_old_device_release = FALSE );


//! eNX`gp󋵂̃Oo
__declspec(dllexport) RESULT ReportTextures( void );

//! XvCggp󋵂̃Oo
__declspec(dllexport) RESULT ReportSprites( void );

//! XvCgobt@eNX`o͂
__declspec(dllexport) RESULT SaveSpriteTempTexture( void );

//! XN[gp󋵂̃Oo
__declspec(dllexport) RESULT ReportScreens( void );

//!	C[gp󋵂̃Oo
__declspec(dllexport) RESULT ReportLayers( void );

//!	C[̃C[Wt@C֕ۑ
/*!
	@param[in] layer_id
	@param[in] pstr_file_path_name
	@param[in] save_width
	@param[in] save_height
*/
__declspec(dllexport) RESULT SaveLayerImage( SBTE_UID layer_id , const SBTE_CHAR* pstr_file_path_name , UINT32 save_width = 0 , UINT32 save_height = 0 );


//! GW̊eW[̃o[W擾
/*!
	@param[out] ret_line_0 ԋppobt@Ps
	@param[in] line_0_size ԋppobt@Psڂ̃TCY
	@param[out] ret_line_1 ԋppobt@QsځANULLȂ擾Ȃ
	@param[in] line_1_size ԋppobt@Qsڂ̃TCY
	@param[out] ret_line_2 ԋppobt@RsځANULLȂ擾Ȃ
	@param[in] line_2_size ԋppobt@Rsڂ̃TCY
*/
__declspec(dllexport) RESULT GetModuleVersions( SBTE_CHAR* ret_line_0 , UINT32 line_0_size , SBTE_CHAR* ret_line_1 = NULL , UINT32 line_1_size = 0 , SBTE_CHAR* ret_line_2 = NULL , UINT32 line_2_size = 0 );

//! `𑜓xύX
/*!
	@param[in] screen_name @\i\j
	@param[in] width V
	@param[in] height V
	
	GWŃEChE쐬ꍇ́AύXłȂB
*/
__declspec(dllexport) RESULT ResizeScreenResolution( SBTE_UID screen_name ,  UINT32 width , UINT32 height );

//! D3DDevice9|C^擾
/*!
	|C^QueryInterface()ꂽ̂ł͂Ȃ̂ŁARelease()Ă͂ȂB@n
	ꂽ|C^D3DDevice9ExQueryInterface()邱ƂłB
*/
__declspec(dllexport) LPDIRECT3DDEVICE9 GetD3DDevice9( void );

//! DLL̃W[nh(hInstance)擾
__declspec(dllexport) HINSTANCE GetInstanceHandle( void );

//! EChEnh(hWnd)擾
/*!
	@param[in] screen_name @\i\j
*/
__declspec(dllexport) HWND GetWindowHandle( SBTE_UID screen_name = 0 );

//! tHg쐬
/*!
	@param[out] ret_h_font 쐬tHg̃nhԂ
	@param[in] font_params tHg̃p[^\
*/
__declspec(dllexport) RESULT CreateFont( HFONT& ret_h_font , FONT_PARAMS& font_params );

//! tHgJ
/*!
	@param[in] h_font JtHg̃nh
*/
__declspec(dllexport) RESULT ReleaseFont( HFONT h_font );


// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// XvCg֌W
// --------------------------------------------------------------------------
//! 摜t@CXvCg`쐬
/*!
	`́A"pstr_group_name/p_define_name"ƂȂ܂B
	
	@param[in] p_define_name ݒ肷`
	@param[in] sprite_define_params 쐬`̃p[^
	@param[in] pstr_group_name `̑O[v
	@param[out] p_ret_id 쐬`ID
*/
__declspec(dllexport) RESULT CreateSpriteDefine( const SBTE_CHAR* p_define_name , const SPRITE_DEFINE_PARAMS& sprite_define_params , const SBTE_CHAR* pstr_group_name = NULL , SPDEF_ID* p_ret_id = NULL );

//! XvCg`ꊇ[ht@CɊ܂܂`擾܂B
/*!
	ꊇ[ht@CSpriteED.exegĐ܂B
	
	@param[in] pstr_defines_file_path XvCgꊇ[ht@C̃pXBexe΂hCu^[t̐΃pXB
*/
__declspec(dllexport) UINT32 GetSpriteDefinesCount( const SBTE_CHAR* pstr_defines_file_path );

//! XvCg`ꊇ[h
/*!
	ꊇ[ht@CSpriteED.exegĐ܂B
	`́A"pstr_group_name/(c[Ŏw肵`)"ƂȂ܂B
	
	@param[in] pstr_defines_file_path GMSPꊇ[ht@C̃pXBexe΂hCu^[t̐΃pXB
	@param[in] pstr_group_name `̑O[v
	@param[out] pa_ret_define_names [h`̈ꗗi[B`ID擾ꍇ́A[GetGMSpriteDefinesCount()̕Ԃl * 1024 * sizeof(SBTE_CHAR)]oCg̃TCYmۂobt@̃|C^n܂B
	@param[out] pa_ret_ids 쐬`ID̈ꗗi[B`ID擾ꍇ́A[GetGMSpriteDefinesCount()̕Ԃl * sizeof(SPDEF_ID)]oCg̃TCYmۂobt@̃|C^n܂B
	@param[in] ret_ids_array_size obt@̃TCYApa_ret_define_names , pa_ret_idsɃobt@̃|C^nꍇɁAGetSpriteDefinesCount()̕Ԃln܂B

	@par `ID̎擾@
	pa_ret_define_names , pa_ret_idsret_ids_array_sizeŎw肵TCỸobt@̃|C^nƁA[h`ID̈ꗗ𓾂邱Ƃł܂B@n
	`&(pa_ret_define_names[i*1024])1000ƂƂĕԂApa_ret_ids[i]ցA̒`ɑΉ`IDԂ܂B@n
	Ƃ`IDGetResUID( define_name )Ő邱Ƃł̂ŁAAv\ߒ`mĂȂ擾Kv͂܂B
*/
__declspec(dllexport) RESULT LoadSpriteDefines( const SBTE_CHAR* pstr_defines_file_path , const SBTE_CHAR* pstr_group_name = NULL , SBTE_CHAR* pa_ret_define_names = NULL , SPDEF_ID* pa_ret_ids = NULL , UINT32 ret_ids_array_size = 0 );


//! GMSPXvCg`P[h
/*!
	gsbAgmbt@CGMSPConv.exeggmsAgmmt@C琶܂B@n
	قȂvWFNg̃t@Cgݍ킹Ă͂܂B
	`́A"pstr_group_name/p_define_name"ƂȂ܂B
	
	@param[in] p_define_name ݒ肷`
	@param[in] pstr_gsb_path gsbt@C̃pXBexe΂hCu^[t̐΃pXB
	@param[in] pstr_gmb_path gmbt@C̃pXBexe΂hCu^[t̐΃pXB
	@param[in] pstr_group_name `̑O[v
	@param[out] p_ret_id 쐬`ID
*/
__declspec(dllexport) RESULT LoadGMSpriteDefine( const SBTE_CHAR* p_define_name , const SBTE_CHAR* pstr_gsb_path , const SBTE_CHAR* pstr_gmb_path , const SBTE_CHAR* pstr_group_name = NULL , SPDEF_ID* p_ret_id = NULL );

//! GMSPXvCg`ꊇ[ht@CɊ܂܂`擾܂B
/*!
	ꊇ[ht@CGMSPConv.exegĐ܂B
	
	@param[in] pstr_defines_file_path GMSPꊇ[ht@C̃pXBexe΂hCu^[t̐΃pXB
*/
__declspec(dllexport) UINT32 GetGMSpriteDefinesCount( const SBTE_CHAR* pstr_defines_file_path );

//! GMSPXvCg`ꊇ[h
/*!
	ꊇ[ht@CGMSPConv.exegĐ܂B@n
	`́A"pstr_group_name/(c[Ŏw肵`)"ƂȂ܂B
	
	@param[in] pstr_defines_file_path GMSPꊇ[ht@C̃pXBexe΂hCu^[t̐΃pXB
	@param[in] pstr_group_name `̑O[v
	@param[out] pa_ret_define_names [h`̈ꗗi[B`ID擾ꍇ́A[GetGMSpriteDefinesCount()̕Ԃl * 1024 * sizeof(SBTE_CHAR)]oCg̃TCYmۂobt@̃|C^n܂B
	@param[out] pa_ret_ids 쐬`ID̈ꗗi[B`ID擾ꍇ́A[GetGMSpriteDefinesCount()̕Ԃl * sizeof(SPDEF_ID)]oCg̃TCYmۂobt@̃|C^n܂B
	@param[in] ret_ids_array_size obt@̃TCYApa_ret_define_names , pa_ret_idsɃobt@̃|C^nꍇɁAGetGMSpriteDefinesCount()̕Ԃln܂B

	@par `ID̎擾@
	pa_ret_define_names , pa_ret_idsret_ids_array_sizeŎw肵TCỸobt@̃|C^nƁA[h`ID̈ꗗ𓾂邱Ƃł܂B@n
	`&(pa_ret_define_names[i*1024])1000ƂƂĕԂApa_ret_ids[i]ցA̒`ɑΉ`IDԂ܂B@n
	Ƃ`IDGetResUID( define_name )Ő邱Ƃł̂ŁAAv\ߒ`mĂȂ擾Kv͂܂B

*/
__declspec(dllexport) RESULT LoadGMSpriteDefines( const SBTE_CHAR* pstr_defines_file_path , const SBTE_CHAR* pstr_group_name = NULL , SBTE_CHAR* pa_ret_define_names = NULL , SPDEF_ID* pa_ret_ids = NULL , UINT32 ret_ids_array_size = 0 );

//! XvCg`jv
/*!
	@param[in] define_id `ID
*/
__declspec(dllexport) RESULT ReleaseSpriteDefine( SPDEF_ID define_id );

//! XvCg`jv
/*!
	@param[in] p_define_name `
*/
__declspec(dllexport) RESULT ReleaseSpriteDefine( const SBTE_CHAR* p_define_name );

//! XvCg`O[vPʂŔjv
/*!
	@param[in] pstr_group_name O[v

	@retval 
*/
__declspec(dllexport) UINT32 ReleaseSpriteDefines( const SBTE_CHAR* pstr_group_name );

//! XvCg`̔jvs
__declspec(dllexport) RESULT RefreshSpriteDefine( void );


//! XvCg쐬
/*!
	@param[out] ret_sprite_id 쐬XvCgID 
	@param[in] define_id XvCg`ID
	@param[in] layer_id `惌C[ID
*/
__declspec(dllexport) RESULT CreateSprite( SP_ID& ret_sprite_id , SPDEF_ID define_id , SBTE_UID layer_id );

//! XvCg쐬
/*!
	@param[in] ret_sprite_id 쐬XvCgID
	@param[in] p_define_name XvCg`
	@param[in] layer_id `惌C[ID
*/
__declspec(dllexport) RESULT CreateSprite( SP_ID& ret_sprite_id , const SBTE_CHAR* p_define_name , SBTE_UID layer_id );

//! XvCgj
/*!
	@param[in] sprite_id XvCgID
*/
__declspec(dllexport) RESULT ReleaseSprite( SP_ID sprite_id );

//! GMXvCg쐬
/*!
	@param[out] ret_sprite_id 쐬GMXvCgID
	@param[in] define_id GMXvCg`ID
	@param[in] layer_id `惌C[ID
*/
__declspec(dllexport) RESULT CreateGMSprite( GMSP_ID& ret_sprite_id , SPDEF_ID define_id , SBTE_UID layer_id );
//! GMXvCg쐬
/*!
	@param[out] ret_sprite_id 쐬GMXvCgID
	@param[in] p_define_name GMXvCg`
	@param[in] layer_id `惌C[ID
*/
__declspec(dllexport) RESULT CreateGMSprite( GMSP_ID& ret_sprite_id , const SBTE_CHAR* p_define_name , SBTE_UID layer_id );

//! GMXvCgj
/*!
	@param[in] sprite_id GMXvCgID
*/
__declspec(dllexport) RESULT ReleaseGMSprite( GMSP_ID sprite_id );

//! XvCg쐬
/*!
	jReleaseSprite()ōs܂B

	@param[out] ret_sprite_id 쐬XvCgID
	@param[in] h_font gptHg̃nhBNULLw肷邩AȒlw肵ꍇ́AftHg̃tHggB
	@param[in] pstr_message ւ̃|C^B֐Iɂ̕ێKv͂܂B
	@param[in] layer_id `ΏƃC[ID
	@param[in] ui_priority `DxBbit0̒l͖܂A܂蕶XvCg̗Dxݒl͂Q݂ƂȂ܂B͔wiFt̕̕\ɂQ̃XvCgd˂Ă邽߂łB
	@param[in] ui_horizontal_origin XvCgX\Wn[0:[_ŉE+][1:S_ŉE+][2:E[_ō+]
	@param[in] ui_vertical_origin XvCgY\Wn[0:[_ŉ+][1:S_ŏ+][2:E[_ŉ+]
	@param[in] b_stretch_h C[̘_TCYɍ킹āA`C[Wgk
	@param[in] b_stretch_v C[̘_TCYɍ킹āA`C[Wgk
	@param[in] b_saturation Zs
	@param[in] b_aa A`GCAXs
	@param[in] b_fix TRUEȂŒ蕶񕝂ŕ`悷AFALSEȂϕ񕝂ŕ`悷B
	@param[in] cr_step_y s̍B0ȂtHg쐬Ɏw肵ftHglgB
	@param[in] f_view_scale `g嗦
	@param[in] b_baseline_placement Y_x[XCʒuɂ
	@param[in] b_right_align El߂ŕ`悷
	@param[in] b_bg wiFLɂBwiF͎w肵ui_priority-1Dx̃XvCgɂĕ`悳܂B]đ̃XvCgƂ̏dˍ킹lꍇɂ́ÃXvCg2ȏDx𗣂ĂB
	@param[out] p_ret_cell_width_table X̕̕𕶎̔zŕԂ(̂2oCg)
*/
__declspec(dllexport) RESULT CreateInscription(
	  SP_ID& ret_sprite_id
	, HFONT h_font
	, const WCHAR* pstr_message
	, SBTE_UID layer_id
	, UINT32 ui_priority
	, UINT32 ui_horizontal_origin
	, UINT32 ui_vertical_origin
	, BOOL b_stretch_h
	, BOOL b_stretch_v
	, BOOL b_saturation
	, BOOL b_aa
	, BOOL b_fix
	, UINT32 cr_step_y
	, float f_view_scale = 1.0f
	, BOOL b_baseline_placement = TRUE
	, BOOL b_right_align = FALSE
	, BOOL b_bg = FALSE
	, MEMORY_ID* p_ret_cell_width_table = NULL
	);

//! v~eBuXvCg쐬
/*!
	jReleaseSprite()ōs܂B

	@param[out] ret_sprite_id 쐬v~eBuXvCgID
	@param[in] type v~eBu̎
	@param[in] layer_id `ΏƃC[ID
	@param[in] ui_priority `Dx
	@param[in] ui_horizontal_origin XvCgX\Wn[0:[_ŉE+][1:S_ŉE+][2:E[_ō+]
	@param[in] ui_vertical_origin XvCgY\Wn[0:[_ŉ+][1:S_ŏ+][2:E[_ŉ+]
	@param[in] b_stretch_h C[̘_TCYɍ킹āA`C[Wgk
	@param[in] b_stretch_v C[̘_TCYɍ킹āA`C[Wgk
	@param[in] b_saturation Zs
	@param[in] b_aa A`GCAXs
	@param[in] f_view_scale `g嗦
*/
__declspec(dllexport) RESULT CreateTofuSprite(
	  SP_ID& ret_sprite_id
	, TOFU_SPRITE_TYPE type
	, SBTE_UID layer_id
	, UINT32 ui_priority
	, UINT32 ui_horizontal_origin
	, UINT32 ui_vertical_origin
	, BOOL b_stretch_h
	, BOOL b_stretch_v
	, BOOL b_saturation
	, BOOL b_aa
	, float f_view_scale = 1.0f
	);

// --------------------------------------------------------------------------
// XvCgnFXvCgAGMXvCgʑ
// --------------------------------------------------------------------------
//! XvCgFL
/*!
	@param[in] sprite_id XvCgID
	@param[in] b_enable Lɂ邩̒l
	@param[in] thread_index (\)0w肷
*/

__declspec(dllexport) RESULT SP_SetEnable( SP_ID sprite_id , BOOL b_enable , UINT32 thread_index = 0 );
//! GMXvCgFL
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] b_enable Lɂ邩̒l
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetEnable( GMSP_ID sprite_id , BOOL b_enable , UINT32 thread_index = 0 );


//! XvCgF
/*!
	@param[in] sprite_id XvCgID
	@param[in] b_visible \邩̒l
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_SetVisible( SP_ID sprite_id , BOOL b_visible , UINT32 thread_index = 0 );

//! GMXvCgF
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] b_visible \邩̒l
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetVisible( GMSP_ID sprite_id , BOOL b_visible , UINT32 thread_index = 0 );


//! XvCgFړ
/*!
	@param[in] sprite_id XvCgID
	@param[in] pv2_position ړW
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_SetPositioning( SP_ID sprite_id , const float* pv2_position , UINT32 thread_index = 0 );

//!	GMXvCgFړ
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] pv2_position ړW
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetPositioning( GMSP_ID sprite_id , const float* pv2_position , UINT32 thread_index = 0 );


//! XvCgFgk
/*!
	@param[in] sprite_id XvCgID
	@param[in] f_scale_x g嗦
	@param[in] f_scale_y cg嗦
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_SetScaling( SP_ID sprite_id , float f_scale_x , float f_scale_y , UINT32 thread_index = 0 );

//! GMXvCgFgk
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] f_scale_x g嗦
	@param[in] f_scale_y cg嗦
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetScaling( GMSP_ID sprite_id , float f_scale_x , float f_scale_y , UINT32 thread_index = 0 );


//! XvCgF]
/*!
	@param[in] sprite_id XvCgID
	@param[in] f_rotate ]px[rad]
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_SetRotation( SP_ID sprite_id , float f_rotate , UINT32 thread_index = 0 );

//! GMXvCgF]
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] f_rotate ]px[rad]
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetRotation( GMSP_ID sprite_id , float f_rotate , UINT32 thread_index = 0 );


//! XvCgFDxύX
/*!
	@param[in] sprite_id XvCgID
	@param[in] ui_priority DxlA傫قǏɕ`悳B0xfffff(20bit)ől
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_SetPriority( SP_ID sprite_id , UINT32 ui_priority , UINT32 thread_index = 0 );

//! GMXvCgFDxύX
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] ui_priority DxlA傫قǏɕ`悳B0xfffff(20bit)ől
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetPriority( GMSP_ID sprite_id , UINT32 ui_priority , UINT32 thread_index = 0 );


//! XvCgFuhFݒ
/*!
	@param[in] sprite_id XvCgID
	@param[in] ui_color J[lB32bit(ARGB)
	@param[in] blend_type uh@
	@param[in] thread_index (\)0w肷

	@note XvCg̓J[uhs܂Bw肵J[lƃXvCgeNX`̃uhŵ݂ƂȂ܂A܂l͏ɏZ܂B
	<table>
	<tr><td>uh@</td><td>uh</td></tr>
	<tr><td>COLOR_BLEND_TYPE__COLMOD_TEXMOD</td><td>wJ[lƃeNX`Z</td></tr>
	<tr><td>COLOR_BLEND_TYPE__COLMOD_TEXADD</td><td>wJ[lƃeNX`Z</td></tr>
	<tr><td>COLOR_BLEND_TYPE__COLADD_TEXMOD</td><td>wJ[lƃeNX`Z</td></tr>
	<tr><td>COLOR_BLEND_TYPE__COLADD_TEXADD</td><td>wJ[lƃeNX`Z</td></tr>
	</table>
*/
__declspec(dllexport) RESULT SP_SetColor( SP_ID sprite_id , UINT32 ui_color , COLOR_BLEND_TYPE blend_type = COLOR_BLEND_TYPE__COLMOD_TEXMOD , UINT32 thread_index = 0 );

//! GMXvCgFuhFݒ
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] ui_color J[lB32bit(ARGB)
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetColor( GMSP_ID sprite_id , UINT32 ui_color , UINT32 thread_index = 0 );


//! XvCgFړAgkA]ꊇw
/*!
	@param[in] sprite_id XvCgID
	@param[in] pv2_position ړW
	@param[in] f_scale_x g嗦
	@param[in] f_scale_y cg嗦
	@param[in] f_rotate ]px[rad]
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_SetPosScalRot( SP_ID sprite_id , const float* pv2_position , float f_scale_x , float f_scale_y , float f_rotate , UINT32 thread_index = 0 );

//! GMXvCgFړAgkA]ꊇw
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] pv2_position ړW
	@param[in] f_scale_x g嗦
	@param[in] f_scale_y cg嗦
	@param[in] f_rotate ]px[rad]
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetPosScalRot( GMSP_ID sprite_id , const float* pv2_position , float f_scale_x , float f_scale_y , float f_rotate , UINT32 thread_index = 0 );


//! XvCgFJփA^b`
/*!
	@param[in] sprite_id XvCgID
	@param[in] camera_id A^b`JID
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_SetCamera( SP_ID sprite_id , CAMERA_ID camera_id , UINT32 thread_index = 0 );

//! GMXvCgFJփA^b`
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] camera_id A^b`JID
*/
__declspec(dllexport) RESULT GMSP_SetCamera( GMSP_ID sprite_id , CAMERA_ID camera_id );


// --------------------------------------------------------------------------
// XvCgnFXvCgp
// --------------------------------------------------------------------------
//! XvCgFUVAj[V̕\R}ݒ
/*!
	@param[in] sprite_id XvCgID
	@param[in] ui_animation_num ݒ肷R}ʒu
	@param[in] b_reverse Aj[VtĐ
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_SetAnimation( SP_ID sprite_id , UINT32 ui_animation_num , BOOL b_reverse , UINT32 thread_index = 0 );

//! XvCgFsUVAj[VRowlw
/*!
	@param[in] sprite_id XvCgID
	@param[in] ui_animation_row sUVAj[VRowl
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_SetMatrixAnimation( SP_ID sprite_id , UINT32 ui_animation_row , UINT32 thread_index = 0 );

//! XvCgF؂蔲`̐ݒi]XvCĝ݁j
/*!
	@param[in] sprite_id XvCgID
	@param[in] pv2_plt ؂蔲`̍W
	@param[in] pv2_volume ؂蔲TCY
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_Scissoring( SP_ID sprite_id , const float* pv2_plt , const float* pv2_volume , UINT32 thread_index = 0 );


// --------------------------------------------------------------------------
// XvCgnFGMXvCgp
// --------------------------------------------------------------------------
//! GMXvCgF[Vw
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] motion_name [VID
	@param[in] begin_frame Jnt[ʒu
	@param[in] ip_frame ݂̃t[̕ԃt[
	@param[in] b_play_motion [VĐJn
	@param[in] b_play_reverse (\)FALSEw肷
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetMotion( GMSP_ID sprite_id , SBTE_UID motion_name , UINT32 begin_frame , UINT32 ip_frame , BOOL b_play_motion = TRUE , BOOL b_play_reverse = FALSE , UINT32 thread_index = 0 );

//! GMXvCgFR{[Vw
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] combo_motion_name R{[VID
	@param[in] begin_frame Jnt[ʒu
	@param[in] ip_frame ݂̃t[̕ԃt[
	@param[in] b_play_motion [VĐJn
	@param[in] b_play_reverse (\)FALSEw肷
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetComboMotion( GMSP_ID sprite_id , SBTE_UID combo_motion_name , UINT32 begin_frame , UINT32 ip_frame , BOOL b_play_motion = TRUE , BOOL b_play_reverse = FALSE , UINT32 thread_index = 0 );

//! GMXvCgF[VĐw(tĐ͌@\Ȃ)
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] b_play_motion [VĐ邩̒l
	@param[in] b_play_reverse (\)FALSEw肷
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetMotionPlayFlags( GMSP_ID sprite_id , BOOL b_play_motion , BOOL b_play_reverse , UINT32 thread_index = 0 );

//! GMXvCgF\ݒ
/*!
	@param[in] sprite_id GMXvCgID
	@param[in] b_force_saturation SẴp[cIɉZŕ`悷
	@param[in] b_force_alpha SẴp[cIɃŕ`悷
	@param[in] b_force_aa SẴp[cIɃA`GCAXONŕ`悷
	@param[in] b_force_no_aa SẴp[cIɃA`GCAXOFFŕ`悷
	@param[in] b_reverse_h SẴp[cIɐ]
	@param[in] b_reverse_v SẴp[cIɐ]
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_SetRenderSetting( GMSP_ID sprite_id , BOOL b_force_saturation , BOOL b_force_alpha , BOOL b_force_aa , BOOL b_force_no_aa , BOOL b_reverse_h , BOOL b_reverse_v , UINT32 thread_index = 0 );

//! GMXvCgFRW̐ݒ
/*!
	RWLƂ邩ǂݒ肵܂BLȃRŴ݂vZAGMSP_GetCalcedCollisions()Ŏ擾\ƂȂ܂B

	@param[in] sprite_id GMXvCgID
	@param[in] b_enable_collisions RW̗LݒB
	@param[in] b_force_calc ȃRWłĂKvZAGMSP_GetCalcedCollisions()Ŏ擾ł悤ɂB
	@param[in] thread_index (\)0w肷

	@note ʏ햳ȃRWib_enable_collisionsݒlA[VݒAp[cݒ肩ʃRW̃L[t[ݒ܂ŕ̃tOANDFALSEƂȂRWj
	̌vZƎ擾͍s܂񂪁Ab_force_calcTRUȄꍇ͕KSẴRWvZA擾悤ɂȂ܂B
*/
__declspec(dllexport) RESULT GMSP_SetCollisionSetting( GMSP_ID sprite_id , BOOL b_enable_collisions , BOOL b_force_calc = FALSE , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
// GMXvCgp[^擾Aݒn
// ̍̊֐͂얢mF
// --------------------------------------------------------------------------
//! ݂̃[hs𓾂B
/*!
	@param[out] pv16_ret_mat_world 擾[hs
	@param[in] gmsp_id GMXvCgID
*/
__declspec(dllexport) RESULT GMSP_GetWorldMatrix( float* pv16_ret_mat_world , GMSP_ID gmsp_id );

//! ݂̎ṕAp[c̃[hs𓾂
/*!
	@param[out] pv16_ret_mat_world 擾p[c̃[hs
	@param[in] gmsp_id GMXvCgID
	@param[in] parts_id Ώۃp[cID
*/
__declspec(dllexport) RESULT GMSP_GetBoneWorldMatrix( float* pv16_ret_mat_world , GMSP_ID gmsp_id , SBTE_UID parts_id );

//! ݂̃[Ṽt[l𓾂
/*!
	@param[in] gmsp_id GMXvCgID

	@return t[ʒu
*/
__declspec(dllexport) UINT32 GMSP_GetCurrentMotionFrame( GMSP_ID gmsp_id );

//! ݂̃[V̎Ԃƍőt[l𓾂
/*!
	@param[out] ret_mot_time ݂̃[Voߎ[sec]
	@param[out] ret_max_mot_time ݂̃[V̍ő厞[sec]
	@param[out] ret_max_mot_frame ݂̃[V̍őt[
	@param[in] gmsp_id GMXvCgID
*/
__declspec(dllexport) RESULT GMSP_GetCurrentMotionMaxParams( float& ret_mot_time , float& ret_max_mot_time , UINT32& ret_max_mot_frame , GMSP_ID gmsp_id );

//! ݂̎p̃RWp[^̐擾
/*!
	@param[in] gmsp_id GMXvCgID
	@return RWԂB
*/
__declspec(dllexport) UINT32 GMSP_GetCalcedCollisionCount( GMSP_ID gmsp_id );

//! ݂̎p̃RWp[^擾AW̓[hl
/*!
	@param[out] pa_ret_collisions 擾RWi[z
	@param[in] array_size ret_collisions̔zTCY(ڐ)B
	@param[in] gmsp_id GMXvCgID

	@par 擾RWɂ
	ret_collisions̍ڐGMSP_GetCalcedCollisionCount()ȏłKv܂B
	܂array_sizeɂ͂̒lݒ肵܂B@n
	݂̃[VAt[ɖȃRW܂܂ꍇA擾łRWf[^
	array_sizeȂȂ܂BۂɎ擾łLȃRW͖̐߂lƂĕԂ܂B
*/
__declspec(dllexport) UINT32 GMSP_GetCalcedCollisions( GMSP_CALCED_COLLISION_PARAMS* pa_ret_collisions , UINT32 array_size , GMSP_ID gmsp_id );

//! p[c̃[JW㏑B(GMSP_UpdateMotionFrame()CalcGMSP()̊ԂŎsKv)
/*!
	@param[in] gmsp_id GMXvCgID
	@param[in] parts_id p[cID
	@param[in] pv16_mat_local ㏑p̍s
*/
__declspec(dllexport) RESULT GMSP_OverwriteGMSPBoneLocalMatrix( GMSP_ID gmsp_id , SBTE_UID parts_id , const float* pv16_mat_local );

//! [VĐǂ𒲂ׂ
/*!
	@param[in] gmsp_id GMXvCgID

	@return ĐȂSUCCEEDEDԂ
*/
__declspec(dllexport) BOOL GMSP_IsMotionPlaying( GMSP_ID gmsp_id );

//! w肵p[c̃C[Wp[^擾
/*!
	@param[out] ret_params 擾p[^
	@param[in] gmsp_id GMXvCgID
	@param[in] parts_id p[cID

*/
__declspec(dllexport) RESULT GMSP_GetPartsImageParams( GMSP_PARTS_IMAGE_PARAMS& ret_params , GMSP_ID gmsp_id , SBTE_UID parts_id );

//! w肵p[c̃C[Wp[^㏑
/*!
	GMSP_Calc()̌ŌĂԂƂŁAp[c̕\Ԃ㏑܂B@n
	(Fj󂳂ꂽp[cȂ)

	@param[in] gmsp_id GMXvCgID
	@param[in] parts_id p[cID
	@param[out] params ㏑p[^


	@return ĐȂSUCCEEDEDԂ
*/
__declspec(dllexport) RESULT GMSP_OverwritePartsImageParams( GMSP_ID gmsp_id , SBTE_UID parts_id , const GMSP_PARTS_IMAGE_PARAMS& params );

//! [VԐisŔ[U[Cxg擾
/*!
	UpdateSBTE()̎sɁAXVɔCxg擾܂BēxUpdateSBTE()sƁA
	ȑOɔCxg͎擾łȂȂ܂B@n
	obt@̃TCYȂꍇFAILEDԂA擾͎s܂B@n
	\ߔł낤Cxg̃TCYzłȂꍇ́Aa_ret_eventsNULLݒ肵ČĂяoƂŁA
	Kvȃobt@̃TCY(sizeof(GMSP_EVENT_PARAMS)P)Ԃ܂B

	@param[out] pa_ret_events CxgԂobt@BNULLw肵ꍇAKvȃobt@̃TCYԂ܂B
	@param[in] event_buffer_size a_ret_events̃TCYw肵܂B
	@param[in] gmsp_id GMXvCgID

	@return 擾Cxg̐ԂACxgȂꍇ0ԂBgmsp_idꍇ0xffffffffԂBa_ret_eventsNULLw肵ꍇ́AKvȃobt@̃TCY(sizeof(GMSP_EVENT_PARAMS)P)ԂB
*/
__declspec(dllexport) UINT32 GMSP_GetRaisedEvent( GMSP_EVENT_PARAMS* pa_ret_events , UINT32 event_buffer_size , GMSP_ID gmsp_id );


// --------------------------------------------------------------------------
// GMXvCgXVn
// --------------------------------------------------------------------------
//! [Ṽt[XV
/*!
	@param[in] gmsp_id GMXvCgID
	@param[in] f_elapsed_time oߎ[sec]
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_UpdateMotionFrame( GMSP_ID gmsp_id , float f_elapsed_time , UINT32 thread_index = 0 );

//! XVꂽt[ɊÂāAp[c̍WvZB
/*!
	@param[in] gmsp_id GMXvCgID
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT GMSP_Calc( GMSP_ID gmsp_id , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
// XvCgJ֘A
// --------------------------------------------------------------------------
//! Jǉ
/*!
	@param[in] ret_camera_id ǉJID
	@param[in] pstr_camera_name ǉJ̖O
*/
__declspec(dllexport) RESULT AddGMSPCamera( SBTE_UID& ret_camera_id , const SBTE_CHAR* pstr_camera_name );

//! Jp[^XV
/*!
	@param[in] camera_id JID
	@param[in] pv2_pos J̍W
	@param[in] f_zoom g嗦A1.0fœ{
*/
__declspec(dllexport) RESULT SetGMSPCameraParams( SBTE_UID camera_id , const float* pv2_pos , float f_zoom );

//! J폜
/*!
	@param[in] camera_id JID
*/
__declspec(dllexport) RESULT RemoveGMSPCamera( SBTE_UID camera_id );

//! J̍W𓾂 
/*!
	@param[out] pv16_ret_mat 擾Js
	@param[in] camera_id JID
*/
__declspec(dllexport) RESULT GetGMSPCameraMatrix( float* pv16_ret_mat , SBTE_UID camera_id );

// --------------------------------------------------------------------------
// XvCg֘A
// --------------------------------------------------------------------------
//! Đݒ肷
/*!
	CreateInscription()Ŏ擾 p_ret_cell_width_table wobt@́AʏSBTE::UpdateSBTE()ɍXV܂A
	b_generate_cell_width_table_immediatelyTRUEɂƑɍXV܂B
	ݒシɕ񕝂~ɂ̂ݎw肵ĉBׂ܂B

	@param[in] sp_id XvCgID
	@param[in] p_string Đݒ肷镶
	@param[in] ui_length 
	@param[in] b_generate_cell_width_table_immediately ̊֐̏IɁAʕobt@XVB
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_InscriptionString( SP_ID sp_id , const WCHAR* p_string , UINT32 ui_length , BOOL b_generate_cell_width_table_immediately = FALSE , UINT32 thread_index = 0 );

//! ̌ʕ̐Fݒ肷
/*!
	b_bg = TRUEō쐬́AƂɔwiFݒ肷邱Ƃł܂B@n
	SP_SetColor()gƁASĂ̕PFAwi𓧖ɐݒ肵܂B

	@param[in] sp_id XvCgID
	@param[in] glyph_coloring F
	@param[in] bg_coloring wiF
	@param[in] glyph_begin_number Ftŏ̈̕ʒu
	@param[in] glyph_count Ft镶B߂Ă͖̂ŁAUINT_MAXw肷Ζ܂œKp܂B
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_GlyphColoring( SP_ID sp_id , UINT32 glyph_coloring , UINT32 bg_coloring , UINT32 glyph_begin_number , UINT32 glyph_count , UINT32 thread_index = 0 );

//! XvCgŜ̃TCY擾
/*!
	SetSprite_InscriptionString()s͕XVsĂȂ߁AÂlԂ܂B@n
	UpdateSBTE()sɐVlԂ܂B

	@param[in] sp_id XvCgID
	@param[out] ret_width XvCg̕
	@param[out] ret_height XvCg̍
*/
__declspec(dllexport) RESULT SP_GetInscriptionSize( SP_ID sp_id , UINT32& ret_width , UINT32& ret_height );


// --------------------------------------------------------------------------
// v~eBuXvCg֘A
// --------------------------------------------------------------------------
//! v~eBuXvCg̊e_ʒuݒ肷
/*!
	_XvCg̏ꍇAP_̍Wɓ_`@n
	XvCg̏ꍇAP_`Q_Ԃɐ`@n
	`XvCg̏ꍇAP_`S_ԂɎlp``B`łȂĂǂA_̕тTriangleStrip^

	@param[in] sp_id XvCgID
	@param[in] pv2_pos0 P_
	@param[in] pv2_pos1 Q_
	@param[in] pv2_pos2 R_
	@param[in] pv2_pos3 S_
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SP_TofuPts( SP_ID sp_id , const float* pv2_pos0 , const float* pv2_pos1 , const float* pv2_pos2 , const float* pv2_pos3 , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
// p[eBNGtFNg֘A
// --------------------------------------------------------------------------

enum PARTICLE_SYNC_ACTION_TYPE
{
	PARTICLE_SYNC_ACTION_TYPE__MOVE			= 0x1,		// p[eBNq̈ʒu𓯊(_͕K)
	PARTICLE_SYNC_ACTION_TYPE__ROTATE		= 0x2,		// ]𓯊
	PARTICLE_SYNC_ACTION_TYPE__SCALE		= 0x4,		// XP[𓯊

	PARTICLE_SYNC_ACTION_TYPE__MRS			= 0x7,		// ړA]AXP[𓯊
	PARTICLE_SYNC_ACTION_TYPE__F32			= 0xffffffff
};

enum PARTICLE_SYNC_LOST_ACTION_TYPE
{
	PARTICLE_SYNC_LOST_ACTION_TYPE__DELETE		= 0,	//!< ɏł܂
	PARTICLE_SYNC_LOST_ACTION_TYPE__STOP_MOVING	= 1,	//!< ̏Œ~܂
	PARTICLE_SYNC_LOST_ACTION_TYPE__KEEP_MOVING	= 2,	//!< ܂ŒÖړxNgA]AXP[̕ψʂێ܂ij
	PARTICLE_SYNC_LOST_ACTION_TYPE__DEC_MOVING	= 3,	//!< ܂ŏXɈړA]AXP[̕ψʗʂ𗎂Ƃ܂ij

	PARTICLE_SYNC_LOST_ACTION_TYPE__F32			= 0xffffffff
};

// --------------------------------------------------------------------------
//! p[eBNGtFNgp[^
struct PARTICLE_PARAMS
{
	SBTE_UID						DefineName;			//!< `IDA[hɎ擾lAGetResUID("O[v:`")œlw肷
	UINT32							RandomSeed;			//!< _V[hlA1`4000܂ł̔Cӂ̒lw肷ƁAp^[̃p[eBNGtFNgB0w肷ƁAp[eBNGtFNg̓VXeKɐݒ肵V[hlpĐ
	float							vPosition[2];		//!< W
	float							fRotate;			//!< px[rad]
	float							vScale[2];			//!< g嗦
	SBTE_UID						LayerID;			//!< `惌C[ID
	CAMERA_ID						CameraID;			//!< A^b`JID
	UINT32							BlendColor;			//!< uhJ[l
	COLOR_BLEND_TYPE				ColorBlendType;		//!< uhJ[lƃf[^IWiF̃uh@
	BOOL							bVisible;			//!< \ԂŐȂTRUE
	float							fFirstTime;			//!< 
	BOOL							bPlay;				//!< シɍĐJnȂTRUE
	BOOL							bSyncGMSPParts;		//!< GMXvCg̃{[ɂȂTRUE
	GMSP_ID							SyncGMSPID;			//!< GMXvCgID
	SBTE_UID						SyncGMSPPartsID;	//!< p[cIDAGetResUID("p[c")
	UINT32							SyncActionFlags;	//!< ^CvwAPARTICLE_SYNC_ACTION_TYPȆgݍ킹
	PARTICLE_SYNC_LOST_ACTION_TYPE	SyncLostActionType;	//!< GMXvCg폜ꂽꍇ̋w

	PARTICLE_PARAMS()
		: DefineName		( 0 )
		, RandomSeed		( 0 )
		, fRotate			( 0.0f )
		, LayerID			( 0 )
		, CameraID			( 0 )	
		, BlendColor		( 0xffffffff )	
		, ColorBlendType	( COLOR_BLEND_TYPE__COLMOD_TEXMOD )
		, bVisible			( TRUE )
		, fFirstTime		( 0.0f )
		, bPlay				( TRUE )
		, bSyncGMSPParts	( FALSE )
		, SyncGMSPID		( 0 )
		, SyncGMSPPartsID	( 0 )
		, SyncActionFlags	( PARTICLE_SYNC_ACTION_TYPE__MRS )
		, SyncLostActionType( PARTICLE_SYNC_LOST_ACTION_TYPE__DELETE )
	{
		vPosition[0]	= 0.0f;
		vPosition[1]	= 0.0f;
		vScale[0]		= 1.0f;
		vScale[1]		= 1.0f;
	};
};

// --------------------------------------------------------------------------
//! p[eBNGtFNg[h
/*!
	GtFNgt@CParticleED.exegĐ܂B
	`́A"pstr_group_name/(c[Ŏw肵`)"ƂȂ܂B
	
	@param[in] pstr_defines_file_path GMSPꊇ[ht@C̃pXBexe΂hCu^[t̐΃pXB
	@param[in] pstr_group_name `̑O[v
	@param[out] pa_ret_define_names [h`̈ꗗi[B`ID擾ꍇ́A[GetGMSpriteDefinesCount()̕Ԃl * 1024 * sizeof(SBTE_CHAR)]oCg̃TCYmۂobt@̃|C^n܂B
	@param[out] pa_ret_ids 쐬`ID̈ꗗi[B`ID擾ꍇ́A[GetGMSpriteDefinesCount()̕Ԃl * sizeof(SPDEF_ID)]oCg̃TCYmۂobt@̃|C^n܂B
	@param[in] ret_ids_array_size obt@̃TCYApa_ret_define_names , pa_ret_idsɃobt@̃|C^nꍇɁAGetSpriteDefinesCount()̕Ԃln܂B

	@par `ID̎擾@
	pa_ret_define_names , pa_ret_idsret_ids_array_sizeŎw肵TCỸobt@̃|C^nƁA[h`ID̈ꗗ𓾂邱Ƃł܂B@n
	`&(pa_ret_define_names[i*1024])1000ƂƂĕԂApa_ret_ids[i]ցA̒`ɑΉ`IDԂ܂B@n
	Ƃ`IDGetResUID( define_name )Ő邱Ƃł̂ŁAAv\ߒ`mĂȂ擾Kv͂܂B

*/
__declspec(dllexport) RESULT LoadParticleEffectDefines( const SBTE_CHAR* pstr_defines_file_path , const SBTE_CHAR* pstr_group_name = NULL , SBTE_CHAR* pa_ret_define_names = NULL , EFDEF_ID* pa_ret_ids = NULL , UINT32 ret_ids_array_size = 0 );

// --------------------------------------------------------------------------
//! p[eBNGtFNg`O[vPʂŔjv
/*!
	@param[in] pstr_group_name O[v

	@retval 
*/
__declspec(dllexport) RESULT ReleaseParticleEffectDefines( const SBTE_CHAR* pstr_group_name );

// --------------------------------------------------------------------------
// p[eBNGtFNgR}h
// --------------------------------------------------------------------------
//! p[eBNGtFNg𐶐
/*!
	@param[in] params p[^
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) EFDEF_ID SetParticleEffect_Create( const PARTICLE_PARAMS& params , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
//! p[eBNGtFNg̈ʒuA]AXP[{ݒ肷
/*!
	@param[in] effect_id Ώۃp[eBNGtFNgID
	@param[in] value_flag 3rbgłꂼ̃p[^Kp邩ǂw肷B
	<table>
	<tr><td>Bit</td><td>Kp</tr>
	<tr><td>Bit 0</td><td>pv_pos</td></tr>
	<tr><td>Bit 1</td><td>f_rotate</td></tr>
	<tr><td>Bit 2</td><td>pv_scale</td></tr>
	</table>
	@param[in] pv_pos WA2floatz
	@param[in] f_rotate ]px[rad]
	@param[in] pv_scale XP[A2floatz 
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SetParticleEffect_PosRotScale( EFDEF_ID effect_id , UINT32 value_flag , const float* pv_pos , float f_rotate , const float* pv_scale , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
//! p[eBNGtFNg̐Fݒ肷(J[R[h)
/*!
	@param[in] effect_id Ώۃp[eBNGtFNgID
	@param[in] color 32bitJ[R[h(0xAARRGGBB)
	@param[in] blend_type ݒ肷J[ƌ̐FƂ̃uh@
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SetParticleEffect_Color( EFDEF_ID effect_id , UINT32 color , COLOR_BLEND_TYPE blend_type = COLOR_BLEND_TYPE__COLMOD_TEXMOD , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
//! p[eBNGtFNg̐Fݒ肷(_l)
/*!
	@param[in] effect_id Ώۃp[eBNGtFNgID
	@param[in] a (0`1)
	@param[in] r (0`1)
	@param[in] g (0`1)
	@param[in] b (0`1)
	@param[in] blend_type ݒ肷J[ƌ̐FƂ̃uh@
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SetParticleEffect_Color( EFDEF_ID effect_id , float a , float r , float g , float b , COLOR_BLEND_TYPE blend_type = COLOR_BLEND_TYPE__COLMOD_TEXMOD , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
//! p[eBNGtFNg̕\Dxw肷
/*! Dx̓XvCgAGMXvCgƓɈ܂B

	@param[in] effect_id Ώۃp[eBNGtFNgID
	@param[in] priority DxB傫Oɕ`悳B
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SetParticleEffect_Priority( EFDEF_ID effect_id , UINT32 priority , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
//! p[eBNGtFNgA^b`Jw肵܂
/*! 
	@param[in] effect_id Ώۃp[eBNGtFNgID
	@param[in] camera_id A^b`JID
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SetParticleEffect_Camera( EFDEF_ID effect_id , CAMERA_ID camera_id , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
//! p[eBNGtFNǧoߎԂݒ肷
/*! ɈӐ}čĐʒuݒ肷ꍇɎgp܂B

	@param[in] effect_id Ώۃp[eBNGtFNgID
	@param[in] f_time w肷oߎ
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SetParticleEffect_Time( EFDEF_ID effect_id , float f_time , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
//! p[eBNGtFNg̍ĐJn/~
/*!
	@param[in] effect_id Ώۃp[eBNGtFNgID
	@param[in] b_play ĐJnȂTRUEA~߂ȂFALSE
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SetParticleEffect_Play( EFDEF_ID effect_id , BOOL b_play , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
//! p[eBNGtFNg폜v
/*!
	@param[in] effect_id Ώۃp[eBNGtFNgID
	@param[in] thread_index (\)0w肷
*/
__declspec(dllexport) RESULT SetParticleEffect_RequestDelete( EFDEF_ID effect_id , UINT32 thread_index = 0 );

// --------------------------------------------------------------------------
//! p[eBNGtFNgׂč폜
/*!
	TEh܂񂾃p[eBN݂ĂԂŁAReleaseSoundEngine()AReleaseSBTE()ɎsƗO܂B
	邽߂ɁAReleaseSoundEngine()̑Oɂ̊֐sĉB
*/
__declspec(dllexport) void ReleaseAllParticleEffect( void );


// --------------------------------------------------------------------------
// ̑
// --------------------------------------------------------------------------
//! MEMORY_ID|C^ɕϊ
/*!
	@param[in] memory_id ϊ郁ID
	@return ϊ̃|C^
*/
__declspec(dllexport) void* GetMemoryPointer( MEMORY_ID memory_id );


// --------------------------------------------------------------------------
//! UTF-16UTF-8֕ϊ
/*! UTF-164oCgɂ͑ΉĂ܂
	@param[out] str_utf8_dest o͐obt@
	@param[in] dest_size o͐obt@̃TCY(oCg)
	@param[in] str_utf16_source ϊ镶
*/
__declspec(dllexport) RESULT ConvertUTF16_to_UTF8( char* str_utf8_dest , UINT32 dest_size , const wchar_t* str_utf16_source );

//! UTF-8UTF-16֕ϊ
/*! UTF-164oCgɂ͑ΉĂ܂
	@param[out] str_utf16_dest o͐obt@
	@param[in] dest_length o͐obt@̃TCY(P)
	@param[in] str_utf8_source ϊ镶
*/
__declspec(dllexport) RESULT ConvertUTF8_to_UTF16( wchar_t* str_utf16_dest , UINT32 dest_length , const char* str_utf8_source );

//! SJISUTF-16֕ϊ
/*! UTF-164oCgɂ͑ΉĂ܂
	@param[out] str_utf16_dest o͐obt@
	@param[in] dest_length o͐obt@̃TCY(P)
	@param[in] str_sjis_source ϊ镶
*/
__declspec(dllexport) RESULT ConvertSJIS_to_UTF16( wchar_t* str_utf16_dest , UINT32 dest_length , const char* str_sjis_source );




}; // namespace SBTE

